// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Telnexus LLC
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package hub

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewDeleteHubParams creates a new DeleteHubParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewDeleteHubParams() *DeleteHubParams {
	return &DeleteHubParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewDeleteHubParamsWithTimeout creates a new DeleteHubParams object
// with the ability to set a timeout on a request.
func NewDeleteHubParamsWithTimeout(timeout time.Duration) *DeleteHubParams {
	return &DeleteHubParams{
		timeout: timeout,
	}
}

// NewDeleteHubParamsWithContext creates a new DeleteHubParams object
// with the ability to set a context for a request.
func NewDeleteHubParamsWithContext(ctx context.Context) *DeleteHubParams {
	return &DeleteHubParams{
		Context: ctx,
	}
}

// NewDeleteHubParamsWithHTTPClient creates a new DeleteHubParams object
// with the ability to set a custom HTTPClient for a request.
func NewDeleteHubParamsWithHTTPClient(client *http.Client) *DeleteHubParams {
	return &DeleteHubParams{
		HTTPClient: client,
	}
}

/* DeleteHubParams contains all the parameters to send to the API endpoint
   for the delete hub operation.

   Typically these are written to a http.Request.
*/
type DeleteHubParams struct {

	/* AccountID.

	   Taxnexus Record Id of an Account
	*/
	AccountID *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the delete hub params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *DeleteHubParams) WithDefaults() *DeleteHubParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the delete hub params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *DeleteHubParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the delete hub params
func (o *DeleteHubParams) WithTimeout(timeout time.Duration) *DeleteHubParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the delete hub params
func (o *DeleteHubParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the delete hub params
func (o *DeleteHubParams) WithContext(ctx context.Context) *DeleteHubParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the delete hub params
func (o *DeleteHubParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the delete hub params
func (o *DeleteHubParams) WithHTTPClient(client *http.Client) *DeleteHubParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the delete hub params
func (o *DeleteHubParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithAccountID adds the accountID to the delete hub params
func (o *DeleteHubParams) WithAccountID(accountID *string) *DeleteHubParams {
	o.SetAccountID(accountID)
	return o
}

// SetAccountID adds the accountId to the delete hub params
func (o *DeleteHubParams) SetAccountID(accountID *string) {
	o.AccountID = accountID
}

// WriteToRequest writes these params to a swagger request
func (o *DeleteHubParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.AccountID != nil {

		// query param accountId
		var qrAccountID string

		if o.AccountID != nil {
			qrAccountID = *o.AccountID
		}
		qAccountID := qrAccountID
		if qAccountID != "" {

			if err := r.SetQueryParam("accountId", qAccountID); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
