// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Telnexus LLC
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package hub

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/telnexus/lib/api/cloud/cloud_models"
)

// PostHubsReader is a Reader for the PostHubs structure.
type PostHubsReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *PostHubsReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewPostHubsOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewPostHubsUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewPostHubsForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewPostHubsNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewPostHubsUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewPostHubsInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		return nil, runtime.NewAPIError("response status code does not match any response statuses defined for this endpoint in the swagger spec", response, response.Code())
	}
}

// NewPostHubsOK creates a PostHubsOK with default headers values
func NewPostHubsOK() *PostHubsOK {
	return &PostHubsOK{}
}

/* PostHubsOK describes a response with status code 200, with default header values.

Telnexus Response with Hub objects
*/
type PostHubsOK struct {
	AccessControlAllowOrigin string
	CacheControl             string

	Payload *cloud_models.HubResponse
}

func (o *PostHubsOK) Error() string {
	return fmt.Sprintf("[POST /hubs][%d] postHubsOK  %+v", 200, o.Payload)
}
func (o *PostHubsOK) GetPayload() *cloud_models.HubResponse {
	return o.Payload
}

func (o *PostHubsOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	// hydrates response header Cache-Control
	hdrCacheControl := response.GetHeader("Cache-Control")

	if hdrCacheControl != "" {
		o.CacheControl = hdrCacheControl
	}

	o.Payload = new(cloud_models.HubResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostHubsUnauthorized creates a PostHubsUnauthorized with default headers values
func NewPostHubsUnauthorized() *PostHubsUnauthorized {
	return &PostHubsUnauthorized{}
}

/* PostHubsUnauthorized describes a response with status code 401, with default header values.

Access Unauthorized, invalid API-KEY was used
*/
type PostHubsUnauthorized struct {
	Payload *cloud_models.Error
}

func (o *PostHubsUnauthorized) Error() string {
	return fmt.Sprintf("[POST /hubs][%d] postHubsUnauthorized  %+v", 401, o.Payload)
}
func (o *PostHubsUnauthorized) GetPayload() *cloud_models.Error {
	return o.Payload
}

func (o *PostHubsUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(cloud_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostHubsForbidden creates a PostHubsForbidden with default headers values
func NewPostHubsForbidden() *PostHubsForbidden {
	return &PostHubsForbidden{}
}

/* PostHubsForbidden describes a response with status code 403, with default header values.

Access forbidden, account lacks access
*/
type PostHubsForbidden struct {
	Payload *cloud_models.Error
}

func (o *PostHubsForbidden) Error() string {
	return fmt.Sprintf("[POST /hubs][%d] postHubsForbidden  %+v", 403, o.Payload)
}
func (o *PostHubsForbidden) GetPayload() *cloud_models.Error {
	return o.Payload
}

func (o *PostHubsForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(cloud_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostHubsNotFound creates a PostHubsNotFound with default headers values
func NewPostHubsNotFound() *PostHubsNotFound {
	return &PostHubsNotFound{}
}

/* PostHubsNotFound describes a response with status code 404, with default header values.

Resource was not found
*/
type PostHubsNotFound struct {
	Payload *cloud_models.Error
}

func (o *PostHubsNotFound) Error() string {
	return fmt.Sprintf("[POST /hubs][%d] postHubsNotFound  %+v", 404, o.Payload)
}
func (o *PostHubsNotFound) GetPayload() *cloud_models.Error {
	return o.Payload
}

func (o *PostHubsNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(cloud_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostHubsUnprocessableEntity creates a PostHubsUnprocessableEntity with default headers values
func NewPostHubsUnprocessableEntity() *PostHubsUnprocessableEntity {
	return &PostHubsUnprocessableEntity{}
}

/* PostHubsUnprocessableEntity describes a response with status code 422, with default header values.

Unprocessable Entity, likely a bad parameter
*/
type PostHubsUnprocessableEntity struct {
	Payload *cloud_models.Error
}

func (o *PostHubsUnprocessableEntity) Error() string {
	return fmt.Sprintf("[POST /hubs][%d] postHubsUnprocessableEntity  %+v", 422, o.Payload)
}
func (o *PostHubsUnprocessableEntity) GetPayload() *cloud_models.Error {
	return o.Payload
}

func (o *PostHubsUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(cloud_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostHubsInternalServerError creates a PostHubsInternalServerError with default headers values
func NewPostHubsInternalServerError() *PostHubsInternalServerError {
	return &PostHubsInternalServerError{}
}

/* PostHubsInternalServerError describes a response with status code 500, with default header values.

Server Internal Error
*/
type PostHubsInternalServerError struct {
	Payload *cloud_models.Error
}

func (o *PostHubsInternalServerError) Error() string {
	return fmt.Sprintf("[POST /hubs][%d] postHubsInternalServerError  %+v", 500, o.Payload)
}
func (o *PostHubsInternalServerError) GetPayload() *cloud_models.Error {
	return o.Payload
}

func (o *PostHubsInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(cloud_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
