// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Telnexus LLC
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package companies

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/telnexus/lib/api/crm/crm_models"
)

// NewPostCompaniesParams creates a new PostCompaniesParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewPostCompaniesParams() *PostCompaniesParams {
	return &PostCompaniesParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewPostCompaniesParamsWithTimeout creates a new PostCompaniesParams object
// with the ability to set a timeout on a request.
func NewPostCompaniesParamsWithTimeout(timeout time.Duration) *PostCompaniesParams {
	return &PostCompaniesParams{
		timeout: timeout,
	}
}

// NewPostCompaniesParamsWithContext creates a new PostCompaniesParams object
// with the ability to set a context for a request.
func NewPostCompaniesParamsWithContext(ctx context.Context) *PostCompaniesParams {
	return &PostCompaniesParams{
		Context: ctx,
	}
}

// NewPostCompaniesParamsWithHTTPClient creates a new PostCompaniesParams object
// with the ability to set a custom HTTPClient for a request.
func NewPostCompaniesParamsWithHTTPClient(client *http.Client) *PostCompaniesParams {
	return &PostCompaniesParams{
		HTTPClient: client,
	}
}

/* PostCompaniesParams contains all the parameters to send to the API endpoint
   for the post companies operation.

   Typically these are written to a http.Request.
*/
type PostCompaniesParams struct {

	/* CompaniesRequest.

	   An array of new Contact records
	*/
	CompaniesRequest *crm_models.CompanyRequest

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the post companies params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PostCompaniesParams) WithDefaults() *PostCompaniesParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the post companies params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PostCompaniesParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the post companies params
func (o *PostCompaniesParams) WithTimeout(timeout time.Duration) *PostCompaniesParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the post companies params
func (o *PostCompaniesParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the post companies params
func (o *PostCompaniesParams) WithContext(ctx context.Context) *PostCompaniesParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the post companies params
func (o *PostCompaniesParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the post companies params
func (o *PostCompaniesParams) WithHTTPClient(client *http.Client) *PostCompaniesParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the post companies params
func (o *PostCompaniesParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithCompaniesRequest adds the companiesRequest to the post companies params
func (o *PostCompaniesParams) WithCompaniesRequest(companiesRequest *crm_models.CompanyRequest) *PostCompaniesParams {
	o.SetCompaniesRequest(companiesRequest)
	return o
}

// SetCompaniesRequest adds the companiesRequest to the post companies params
func (o *PostCompaniesParams) SetCompaniesRequest(companiesRequest *crm_models.CompanyRequest) {
	o.CompaniesRequest = companiesRequest
}

// WriteToRequest writes these params to a swagger request
func (o *PostCompaniesParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.CompaniesRequest != nil {
		if err := r.SetBodyParam(o.CompaniesRequest); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
