// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Telnexus LLC
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package contacts

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/telnexus/lib/api/crm/crm_models"
)

// GetContactsReader is a Reader for the GetContacts structure.
type GetContactsReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetContactsReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetContactsOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewGetContactsUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewGetContactsForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewGetContactsNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewGetContactsUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewGetContactsInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		return nil, runtime.NewAPIError("response status code does not match any response statuses defined for this endpoint in the swagger spec", response, response.Code())
	}
}

// NewGetContactsOK creates a GetContactsOK with default headers values
func NewGetContactsOK() *GetContactsOK {
	return &GetContactsOK{}
}

/* GetContactsOK describes a response with status code 200, with default header values.

Telnexus Response with an array of Contact objects
*/
type GetContactsOK struct {
	AccessControlAllowOrigin string
	CacheControl             string

	Payload *crm_models.ContactResponse
}

func (o *GetContactsOK) Error() string {
	return fmt.Sprintf("[GET /contacts][%d] getContactsOK  %+v", 200, o.Payload)
}
func (o *GetContactsOK) GetPayload() *crm_models.ContactResponse {
	return o.Payload
}

func (o *GetContactsOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	// hydrates response header Cache-Control
	hdrCacheControl := response.GetHeader("Cache-Control")

	if hdrCacheControl != "" {
		o.CacheControl = hdrCacheControl
	}

	o.Payload = new(crm_models.ContactResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetContactsUnauthorized creates a GetContactsUnauthorized with default headers values
func NewGetContactsUnauthorized() *GetContactsUnauthorized {
	return &GetContactsUnauthorized{}
}

/* GetContactsUnauthorized describes a response with status code 401, with default header values.

Access unauthorized, invalid API-KEY was used
*/
type GetContactsUnauthorized struct {
	AccessControlAllowOrigin string

	Payload *crm_models.Error
}

func (o *GetContactsUnauthorized) Error() string {
	return fmt.Sprintf("[GET /contacts][%d] getContactsUnauthorized  %+v", 401, o.Payload)
}
func (o *GetContactsUnauthorized) GetPayload() *crm_models.Error {
	return o.Payload
}

func (o *GetContactsUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(crm_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetContactsForbidden creates a GetContactsForbidden with default headers values
func NewGetContactsForbidden() *GetContactsForbidden {
	return &GetContactsForbidden{}
}

/* GetContactsForbidden describes a response with status code 403, with default header values.

Access forbidden, account lacks access
*/
type GetContactsForbidden struct {
	AccessControlAllowOrigin string

	Payload *crm_models.Error
}

func (o *GetContactsForbidden) Error() string {
	return fmt.Sprintf("[GET /contacts][%d] getContactsForbidden  %+v", 403, o.Payload)
}
func (o *GetContactsForbidden) GetPayload() *crm_models.Error {
	return o.Payload
}

func (o *GetContactsForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(crm_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetContactsNotFound creates a GetContactsNotFound with default headers values
func NewGetContactsNotFound() *GetContactsNotFound {
	return &GetContactsNotFound{}
}

/* GetContactsNotFound describes a response with status code 404, with default header values.

Resource was not found
*/
type GetContactsNotFound struct {
	AccessControlAllowOrigin string

	Payload *crm_models.Error
}

func (o *GetContactsNotFound) Error() string {
	return fmt.Sprintf("[GET /contacts][%d] getContactsNotFound  %+v", 404, o.Payload)
}
func (o *GetContactsNotFound) GetPayload() *crm_models.Error {
	return o.Payload
}

func (o *GetContactsNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(crm_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetContactsUnprocessableEntity creates a GetContactsUnprocessableEntity with default headers values
func NewGetContactsUnprocessableEntity() *GetContactsUnprocessableEntity {
	return &GetContactsUnprocessableEntity{}
}

/* GetContactsUnprocessableEntity describes a response with status code 422, with default header values.

Unprocessable Entity, likely a bad parameter
*/
type GetContactsUnprocessableEntity struct {
	AccessControlAllowOrigin string

	Payload *crm_models.Error
}

func (o *GetContactsUnprocessableEntity) Error() string {
	return fmt.Sprintf("[GET /contacts][%d] getContactsUnprocessableEntity  %+v", 422, o.Payload)
}
func (o *GetContactsUnprocessableEntity) GetPayload() *crm_models.Error {
	return o.Payload
}

func (o *GetContactsUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(crm_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetContactsInternalServerError creates a GetContactsInternalServerError with default headers values
func NewGetContactsInternalServerError() *GetContactsInternalServerError {
	return &GetContactsInternalServerError{}
}

/* GetContactsInternalServerError describes a response with status code 500, with default header values.

Server Internal Error
*/
type GetContactsInternalServerError struct {
	AccessControlAllowOrigin string

	Payload *crm_models.Error
}

func (o *GetContactsInternalServerError) Error() string {
	return fmt.Sprintf("[GET /contacts][%d] getContactsInternalServerError  %+v", 500, o.Payload)
}
func (o *GetContactsInternalServerError) GetPayload() *crm_models.Error {
	return o.Payload
}

func (o *GetContactsInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(crm_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
