// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Telnexus LLC
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package contacts

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/telnexus/lib/api/crm/crm_models"
)

// PutContactsReader is a Reader for the PutContacts structure.
type PutContactsReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *PutContactsReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewPutContactsOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewPutContactsUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewPutContactsForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewPutContactsNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewPutContactsUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewPutContactsInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		return nil, runtime.NewAPIError("response status code does not match any response statuses defined for this endpoint in the swagger spec", response, response.Code())
	}
}

// NewPutContactsOK creates a PutContactsOK with default headers values
func NewPutContactsOK() *PutContactsOK {
	return &PutContactsOK{}
}

/* PutContactsOK describes a response with status code 200, with default header values.

Telnexus Response with an array of Contact objects
*/
type PutContactsOK struct {
	AccessControlAllowOrigin string
	CacheControl             string

	Payload *crm_models.ContactResponse
}

func (o *PutContactsOK) Error() string {
	return fmt.Sprintf("[PUT /contacts][%d] putContactsOK  %+v", 200, o.Payload)
}
func (o *PutContactsOK) GetPayload() *crm_models.ContactResponse {
	return o.Payload
}

func (o *PutContactsOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	// hydrates response header Cache-Control
	hdrCacheControl := response.GetHeader("Cache-Control")

	if hdrCacheControl != "" {
		o.CacheControl = hdrCacheControl
	}

	o.Payload = new(crm_models.ContactResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutContactsUnauthorized creates a PutContactsUnauthorized with default headers values
func NewPutContactsUnauthorized() *PutContactsUnauthorized {
	return &PutContactsUnauthorized{}
}

/* PutContactsUnauthorized describes a response with status code 401, with default header values.

Access unauthorized, invalid API-KEY was used
*/
type PutContactsUnauthorized struct {
	AccessControlAllowOrigin string

	Payload *crm_models.Error
}

func (o *PutContactsUnauthorized) Error() string {
	return fmt.Sprintf("[PUT /contacts][%d] putContactsUnauthorized  %+v", 401, o.Payload)
}
func (o *PutContactsUnauthorized) GetPayload() *crm_models.Error {
	return o.Payload
}

func (o *PutContactsUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(crm_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutContactsForbidden creates a PutContactsForbidden with default headers values
func NewPutContactsForbidden() *PutContactsForbidden {
	return &PutContactsForbidden{}
}

/* PutContactsForbidden describes a response with status code 403, with default header values.

Access forbidden, account lacks access
*/
type PutContactsForbidden struct {
	AccessControlAllowOrigin string

	Payload *crm_models.Error
}

func (o *PutContactsForbidden) Error() string {
	return fmt.Sprintf("[PUT /contacts][%d] putContactsForbidden  %+v", 403, o.Payload)
}
func (o *PutContactsForbidden) GetPayload() *crm_models.Error {
	return o.Payload
}

func (o *PutContactsForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(crm_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutContactsNotFound creates a PutContactsNotFound with default headers values
func NewPutContactsNotFound() *PutContactsNotFound {
	return &PutContactsNotFound{}
}

/* PutContactsNotFound describes a response with status code 404, with default header values.

Resource was not found
*/
type PutContactsNotFound struct {
	AccessControlAllowOrigin string

	Payload *crm_models.Error
}

func (o *PutContactsNotFound) Error() string {
	return fmt.Sprintf("[PUT /contacts][%d] putContactsNotFound  %+v", 404, o.Payload)
}
func (o *PutContactsNotFound) GetPayload() *crm_models.Error {
	return o.Payload
}

func (o *PutContactsNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(crm_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutContactsUnprocessableEntity creates a PutContactsUnprocessableEntity with default headers values
func NewPutContactsUnprocessableEntity() *PutContactsUnprocessableEntity {
	return &PutContactsUnprocessableEntity{}
}

/* PutContactsUnprocessableEntity describes a response with status code 422, with default header values.

Unprocessable Entity, likely a bad parameter
*/
type PutContactsUnprocessableEntity struct {
	AccessControlAllowOrigin string

	Payload *crm_models.Error
}

func (o *PutContactsUnprocessableEntity) Error() string {
	return fmt.Sprintf("[PUT /contacts][%d] putContactsUnprocessableEntity  %+v", 422, o.Payload)
}
func (o *PutContactsUnprocessableEntity) GetPayload() *crm_models.Error {
	return o.Payload
}

func (o *PutContactsUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(crm_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutContactsInternalServerError creates a PutContactsInternalServerError with default headers values
func NewPutContactsInternalServerError() *PutContactsInternalServerError {
	return &PutContactsInternalServerError{}
}

/* PutContactsInternalServerError describes a response with status code 500, with default header values.

Server Internal Error
*/
type PutContactsInternalServerError struct {
	AccessControlAllowOrigin string

	Payload *crm_models.Error
}

func (o *PutContactsInternalServerError) Error() string {
	return fmt.Sprintf("[PUT /contacts][%d] putContactsInternalServerError  %+v", 500, o.Payload)
}
func (o *PutContactsInternalServerError) GetPayload() *crm_models.Error {
	return o.Payload
}

func (o *PutContactsInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(crm_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
