// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Telnexus LLC
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package leads

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/telnexus/lib/api/crm/crm_models"
)

// NewPutLeadsParams creates a new PutLeadsParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewPutLeadsParams() *PutLeadsParams {
	return &PutLeadsParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewPutLeadsParamsWithTimeout creates a new PutLeadsParams object
// with the ability to set a timeout on a request.
func NewPutLeadsParamsWithTimeout(timeout time.Duration) *PutLeadsParams {
	return &PutLeadsParams{
		timeout: timeout,
	}
}

// NewPutLeadsParamsWithContext creates a new PutLeadsParams object
// with the ability to set a context for a request.
func NewPutLeadsParamsWithContext(ctx context.Context) *PutLeadsParams {
	return &PutLeadsParams{
		Context: ctx,
	}
}

// NewPutLeadsParamsWithHTTPClient creates a new PutLeadsParams object
// with the ability to set a custom HTTPClient for a request.
func NewPutLeadsParamsWithHTTPClient(client *http.Client) *PutLeadsParams {
	return &PutLeadsParams{
		HTTPClient: client,
	}
}

/* PutLeadsParams contains all the parameters to send to the API endpoint
   for the put leads operation.

   Typically these are written to a http.Request.
*/
type PutLeadsParams struct {

	/* LeadRequest.

	   An array of new Lead records
	*/
	LeadRequest *crm_models.LeadRequest

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the put leads params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PutLeadsParams) WithDefaults() *PutLeadsParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the put leads params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PutLeadsParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the put leads params
func (o *PutLeadsParams) WithTimeout(timeout time.Duration) *PutLeadsParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the put leads params
func (o *PutLeadsParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the put leads params
func (o *PutLeadsParams) WithContext(ctx context.Context) *PutLeadsParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the put leads params
func (o *PutLeadsParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the put leads params
func (o *PutLeadsParams) WithHTTPClient(client *http.Client) *PutLeadsParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the put leads params
func (o *PutLeadsParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithLeadRequest adds the leadRequest to the put leads params
func (o *PutLeadsParams) WithLeadRequest(leadRequest *crm_models.LeadRequest) *PutLeadsParams {
	o.SetLeadRequest(leadRequest)
	return o
}

// SetLeadRequest adds the leadRequest to the put leads params
func (o *PutLeadsParams) SetLeadRequest(leadRequest *crm_models.LeadRequest) {
	o.LeadRequest = leadRequest
}

// WriteToRequest writes these params to a swagger request
func (o *PutLeadsParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.LeadRequest != nil {
		if err := r.SetBodyParam(o.LeadRequest); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
