// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Telnexus LLC
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package leads

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/telnexus/lib/api/crm/crm_models"
)

// PutLeadsReader is a Reader for the PutLeads structure.
type PutLeadsReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *PutLeadsReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewPutLeadsOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewPutLeadsUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewPutLeadsForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewPutLeadsNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewPutLeadsUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewPutLeadsInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		return nil, runtime.NewAPIError("response status code does not match any response statuses defined for this endpoint in the swagger spec", response, response.Code())
	}
}

// NewPutLeadsOK creates a PutLeadsOK with default headers values
func NewPutLeadsOK() *PutLeadsOK {
	return &PutLeadsOK{}
}

/* PutLeadsOK describes a response with status code 200, with default header values.

Telnexus Response with an array of Lead objects
*/
type PutLeadsOK struct {
	AccessControlAllowOrigin string
	CacheControl             string

	Payload *crm_models.LeadResponse
}

func (o *PutLeadsOK) Error() string {
	return fmt.Sprintf("[PUT /leads][%d] putLeadsOK  %+v", 200, o.Payload)
}
func (o *PutLeadsOK) GetPayload() *crm_models.LeadResponse {
	return o.Payload
}

func (o *PutLeadsOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	// hydrates response header Cache-Control
	hdrCacheControl := response.GetHeader("Cache-Control")

	if hdrCacheControl != "" {
		o.CacheControl = hdrCacheControl
	}

	o.Payload = new(crm_models.LeadResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutLeadsUnauthorized creates a PutLeadsUnauthorized with default headers values
func NewPutLeadsUnauthorized() *PutLeadsUnauthorized {
	return &PutLeadsUnauthorized{}
}

/* PutLeadsUnauthorized describes a response with status code 401, with default header values.

Access unauthorized, invalid API-KEY was used
*/
type PutLeadsUnauthorized struct {
	AccessControlAllowOrigin string

	Payload *crm_models.Error
}

func (o *PutLeadsUnauthorized) Error() string {
	return fmt.Sprintf("[PUT /leads][%d] putLeadsUnauthorized  %+v", 401, o.Payload)
}
func (o *PutLeadsUnauthorized) GetPayload() *crm_models.Error {
	return o.Payload
}

func (o *PutLeadsUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(crm_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutLeadsForbidden creates a PutLeadsForbidden with default headers values
func NewPutLeadsForbidden() *PutLeadsForbidden {
	return &PutLeadsForbidden{}
}

/* PutLeadsForbidden describes a response with status code 403, with default header values.

Access forbidden, account lacks access
*/
type PutLeadsForbidden struct {
	AccessControlAllowOrigin string

	Payload *crm_models.Error
}

func (o *PutLeadsForbidden) Error() string {
	return fmt.Sprintf("[PUT /leads][%d] putLeadsForbidden  %+v", 403, o.Payload)
}
func (o *PutLeadsForbidden) GetPayload() *crm_models.Error {
	return o.Payload
}

func (o *PutLeadsForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(crm_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutLeadsNotFound creates a PutLeadsNotFound with default headers values
func NewPutLeadsNotFound() *PutLeadsNotFound {
	return &PutLeadsNotFound{}
}

/* PutLeadsNotFound describes a response with status code 404, with default header values.

Resource was not found
*/
type PutLeadsNotFound struct {
	AccessControlAllowOrigin string

	Payload *crm_models.Error
}

func (o *PutLeadsNotFound) Error() string {
	return fmt.Sprintf("[PUT /leads][%d] putLeadsNotFound  %+v", 404, o.Payload)
}
func (o *PutLeadsNotFound) GetPayload() *crm_models.Error {
	return o.Payload
}

func (o *PutLeadsNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(crm_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutLeadsUnprocessableEntity creates a PutLeadsUnprocessableEntity with default headers values
func NewPutLeadsUnprocessableEntity() *PutLeadsUnprocessableEntity {
	return &PutLeadsUnprocessableEntity{}
}

/* PutLeadsUnprocessableEntity describes a response with status code 422, with default header values.

Unprocessable Entity, likely a bad parameter
*/
type PutLeadsUnprocessableEntity struct {
	AccessControlAllowOrigin string

	Payload *crm_models.Error
}

func (o *PutLeadsUnprocessableEntity) Error() string {
	return fmt.Sprintf("[PUT /leads][%d] putLeadsUnprocessableEntity  %+v", 422, o.Payload)
}
func (o *PutLeadsUnprocessableEntity) GetPayload() *crm_models.Error {
	return o.Payload
}

func (o *PutLeadsUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(crm_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutLeadsInternalServerError creates a PutLeadsInternalServerError with default headers values
func NewPutLeadsInternalServerError() *PutLeadsInternalServerError {
	return &PutLeadsInternalServerError{}
}

/* PutLeadsInternalServerError describes a response with status code 500, with default header values.

Server Internal Error
*/
type PutLeadsInternalServerError struct {
	AccessControlAllowOrigin string

	Payload *crm_models.Error
}

func (o *PutLeadsInternalServerError) Error() string {
	return fmt.Sprintf("[PUT /leads][%d] putLeadsInternalServerError  %+v", 500, o.Payload)
}
func (o *PutLeadsInternalServerError) GetPayload() *crm_models.Error {
	return o.Payload
}

func (o *PutLeadsInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(crm_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
