// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Telnexus LLC
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package cluster

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/telnexus/lib/api/devops/devops_models"
)

// GetClustersObservableReader is a Reader for the GetClustersObservable structure.
type GetClustersObservableReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetClustersObservableReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetClustersObservableOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewGetClustersObservableUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewGetClustersObservableForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewGetClustersObservableNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewGetClustersObservableUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewGetClustersObservableInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		return nil, runtime.NewAPIError("response status code does not match any response statuses defined for this endpoint in the swagger spec", response, response.Code())
	}
}

// NewGetClustersObservableOK creates a GetClustersObservableOK with default headers values
func NewGetClustersObservableOK() *GetClustersObservableOK {
	return &GetClustersObservableOK{}
}

/* GetClustersObservableOK describes a response with status code 200, with default header values.

Single Cluster record response
*/
type GetClustersObservableOK struct {
	AccessControlAllowOrigin string
	CacheControl             string

	Payload []*devops_models.Cluster
}

func (o *GetClustersObservableOK) Error() string {
	return fmt.Sprintf("[GET /clusters/observable][%d] getClustersObservableOK  %+v", 200, o.Payload)
}
func (o *GetClustersObservableOK) GetPayload() []*devops_models.Cluster {
	return o.Payload
}

func (o *GetClustersObservableOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	// hydrates response header Cache-Control
	hdrCacheControl := response.GetHeader("Cache-Control")

	if hdrCacheControl != "" {
		o.CacheControl = hdrCacheControl
	}

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetClustersObservableUnauthorized creates a GetClustersObservableUnauthorized with default headers values
func NewGetClustersObservableUnauthorized() *GetClustersObservableUnauthorized {
	return &GetClustersObservableUnauthorized{}
}

/* GetClustersObservableUnauthorized describes a response with status code 401, with default header values.

Access Unauthorized, invalid API-KEY was used
*/
type GetClustersObservableUnauthorized struct {
	AccessControlAllowOrigin string
	CacheControl             string

	Payload *devops_models.Error
}

func (o *GetClustersObservableUnauthorized) Error() string {
	return fmt.Sprintf("[GET /clusters/observable][%d] getClustersObservableUnauthorized  %+v", 401, o.Payload)
}
func (o *GetClustersObservableUnauthorized) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *GetClustersObservableUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	// hydrates response header Cache-Control
	hdrCacheControl := response.GetHeader("Cache-Control")

	if hdrCacheControl != "" {
		o.CacheControl = hdrCacheControl
	}

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetClustersObservableForbidden creates a GetClustersObservableForbidden with default headers values
func NewGetClustersObservableForbidden() *GetClustersObservableForbidden {
	return &GetClustersObservableForbidden{}
}

/* GetClustersObservableForbidden describes a response with status code 403, with default header values.

Access forbidden, account lacks access
*/
type GetClustersObservableForbidden struct {
	AccessControlAllowOrigin string

	Payload *devops_models.Error
}

func (o *GetClustersObservableForbidden) Error() string {
	return fmt.Sprintf("[GET /clusters/observable][%d] getClustersObservableForbidden  %+v", 403, o.Payload)
}
func (o *GetClustersObservableForbidden) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *GetClustersObservableForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetClustersObservableNotFound creates a GetClustersObservableNotFound with default headers values
func NewGetClustersObservableNotFound() *GetClustersObservableNotFound {
	return &GetClustersObservableNotFound{}
}

/* GetClustersObservableNotFound describes a response with status code 404, with default header values.

Resource was not found
*/
type GetClustersObservableNotFound struct {
	AccessControlAllowOrigin string

	Payload *devops_models.Error
}

func (o *GetClustersObservableNotFound) Error() string {
	return fmt.Sprintf("[GET /clusters/observable][%d] getClustersObservableNotFound  %+v", 404, o.Payload)
}
func (o *GetClustersObservableNotFound) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *GetClustersObservableNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetClustersObservableUnprocessableEntity creates a GetClustersObservableUnprocessableEntity with default headers values
func NewGetClustersObservableUnprocessableEntity() *GetClustersObservableUnprocessableEntity {
	return &GetClustersObservableUnprocessableEntity{}
}

/* GetClustersObservableUnprocessableEntity describes a response with status code 422, with default header values.

Unprocessable Entity, likely a bad parameter
*/
type GetClustersObservableUnprocessableEntity struct {
	AccessControlAllowOrigin string
	CacheControl             string

	Payload *devops_models.Error
}

func (o *GetClustersObservableUnprocessableEntity) Error() string {
	return fmt.Sprintf("[GET /clusters/observable][%d] getClustersObservableUnprocessableEntity  %+v", 422, o.Payload)
}
func (o *GetClustersObservableUnprocessableEntity) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *GetClustersObservableUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	// hydrates response header Cache-Control
	hdrCacheControl := response.GetHeader("Cache-Control")

	if hdrCacheControl != "" {
		o.CacheControl = hdrCacheControl
	}

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetClustersObservableInternalServerError creates a GetClustersObservableInternalServerError with default headers values
func NewGetClustersObservableInternalServerError() *GetClustersObservableInternalServerError {
	return &GetClustersObservableInternalServerError{}
}

/* GetClustersObservableInternalServerError describes a response with status code 500, with default header values.

Server Internal Error
*/
type GetClustersObservableInternalServerError struct {
	AccessControlAllowOrigin string

	Payload *devops_models.Error
}

func (o *GetClustersObservableInternalServerError) Error() string {
	return fmt.Sprintf("[GET /clusters/observable][%d] getClustersObservableInternalServerError  %+v", 500, o.Payload)
}
func (o *GetClustersObservableInternalServerError) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *GetClustersObservableInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
