// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Telnexus LLC
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package ingest

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/telnexus/lib/api/devops/devops_models"
)

// NewPostIngestsParams creates a new PostIngestsParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewPostIngestsParams() *PostIngestsParams {
	return &PostIngestsParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewPostIngestsParamsWithTimeout creates a new PostIngestsParams object
// with the ability to set a timeout on a request.
func NewPostIngestsParamsWithTimeout(timeout time.Duration) *PostIngestsParams {
	return &PostIngestsParams{
		timeout: timeout,
	}
}

// NewPostIngestsParamsWithContext creates a new PostIngestsParams object
// with the ability to set a context for a request.
func NewPostIngestsParamsWithContext(ctx context.Context) *PostIngestsParams {
	return &PostIngestsParams{
		Context: ctx,
	}
}

// NewPostIngestsParamsWithHTTPClient creates a new PostIngestsParams object
// with the ability to set a custom HTTPClient for a request.
func NewPostIngestsParamsWithHTTPClient(client *http.Client) *PostIngestsParams {
	return &PostIngestsParams{
		HTTPClient: client,
	}
}

/* PostIngestsParams contains all the parameters to send to the API endpoint
   for the post ingests operation.

   Typically these are written to a http.Request.
*/
type PostIngestsParams struct {

	/* IngestRequest.

	   An array of Ingest records
	*/
	IngestRequest *devops_models.IngestRequest

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the post ingests params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PostIngestsParams) WithDefaults() *PostIngestsParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the post ingests params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PostIngestsParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the post ingests params
func (o *PostIngestsParams) WithTimeout(timeout time.Duration) *PostIngestsParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the post ingests params
func (o *PostIngestsParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the post ingests params
func (o *PostIngestsParams) WithContext(ctx context.Context) *PostIngestsParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the post ingests params
func (o *PostIngestsParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the post ingests params
func (o *PostIngestsParams) WithHTTPClient(client *http.Client) *PostIngestsParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the post ingests params
func (o *PostIngestsParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithIngestRequest adds the ingestRequest to the post ingests params
func (o *PostIngestsParams) WithIngestRequest(ingestRequest *devops_models.IngestRequest) *PostIngestsParams {
	o.SetIngestRequest(ingestRequest)
	return o
}

// SetIngestRequest adds the ingestRequest to the post ingests params
func (o *PostIngestsParams) SetIngestRequest(ingestRequest *devops_models.IngestRequest) {
	o.IngestRequest = ingestRequest
}

// WriteToRequest writes these params to a swagger request
func (o *PostIngestsParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.IngestRequest != nil {
		if err := r.SetBodyParam(o.IngestRequest); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
