// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Telnexus LLC
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package job

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/telnexus/lib/api/devops/devops_models"
)

// NewPutJobsParams creates a new PutJobsParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewPutJobsParams() *PutJobsParams {
	return &PutJobsParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewPutJobsParamsWithTimeout creates a new PutJobsParams object
// with the ability to set a timeout on a request.
func NewPutJobsParamsWithTimeout(timeout time.Duration) *PutJobsParams {
	return &PutJobsParams{
		timeout: timeout,
	}
}

// NewPutJobsParamsWithContext creates a new PutJobsParams object
// with the ability to set a context for a request.
func NewPutJobsParamsWithContext(ctx context.Context) *PutJobsParams {
	return &PutJobsParams{
		Context: ctx,
	}
}

// NewPutJobsParamsWithHTTPClient creates a new PutJobsParams object
// with the ability to set a custom HTTPClient for a request.
func NewPutJobsParamsWithHTTPClient(client *http.Client) *PutJobsParams {
	return &PutJobsParams{
		HTTPClient: client,
	}
}

/* PutJobsParams contains all the parameters to send to the API endpoint
   for the put jobs operation.

   Typically these are written to a http.Request.
*/
type PutJobsParams struct {

	/* JobRequest.

	   An array of Job records
	*/
	JobRequest *devops_models.JobRequest

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the put jobs params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PutJobsParams) WithDefaults() *PutJobsParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the put jobs params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PutJobsParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the put jobs params
func (o *PutJobsParams) WithTimeout(timeout time.Duration) *PutJobsParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the put jobs params
func (o *PutJobsParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the put jobs params
func (o *PutJobsParams) WithContext(ctx context.Context) *PutJobsParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the put jobs params
func (o *PutJobsParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the put jobs params
func (o *PutJobsParams) WithHTTPClient(client *http.Client) *PutJobsParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the put jobs params
func (o *PutJobsParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithJobRequest adds the jobRequest to the put jobs params
func (o *PutJobsParams) WithJobRequest(jobRequest *devops_models.JobRequest) *PutJobsParams {
	o.SetJobRequest(jobRequest)
	return o
}

// SetJobRequest adds the jobRequest to the put jobs params
func (o *PutJobsParams) SetJobRequest(jobRequest *devops_models.JobRequest) {
	o.JobRequest = jobRequest
}

// WriteToRequest writes these params to a swagger request
func (o *PutJobsParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.JobRequest != nil {
		if err := r.SetBodyParam(o.JobRequest); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
