// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Telnexus LLC
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package service

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewGetServicesParams creates a new GetServicesParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewGetServicesParams() *GetServicesParams {
	return &GetServicesParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewGetServicesParamsWithTimeout creates a new GetServicesParams object
// with the ability to set a timeout on a request.
func NewGetServicesParamsWithTimeout(timeout time.Duration) *GetServicesParams {
	return &GetServicesParams{
		timeout: timeout,
	}
}

// NewGetServicesParamsWithContext creates a new GetServicesParams object
// with the ability to set a context for a request.
func NewGetServicesParamsWithContext(ctx context.Context) *GetServicesParams {
	return &GetServicesParams{
		Context: ctx,
	}
}

// NewGetServicesParamsWithHTTPClient creates a new GetServicesParams object
// with the ability to set a custom HTTPClient for a request.
func NewGetServicesParamsWithHTTPClient(client *http.Client) *GetServicesParams {
	return &GetServicesParams{
		HTTPClient: client,
	}
}

/* GetServicesParams contains all the parameters to send to the API endpoint
   for the get services operation.

   Typically these are written to a http.Request.
*/
type GetServicesParams struct {

	/* Limit.

	   How many objects to return at one time

	   Format: int64
	*/
	Limit *int64

	/* Offset.

	   How many objects to skip? (default 0)

	   Format: int64
	*/
	Offset *int64

	/* ServiceID.

	   Service ID
	*/
	ServiceID *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the get services params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetServicesParams) WithDefaults() *GetServicesParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the get services params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetServicesParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the get services params
func (o *GetServicesParams) WithTimeout(timeout time.Duration) *GetServicesParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get services params
func (o *GetServicesParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get services params
func (o *GetServicesParams) WithContext(ctx context.Context) *GetServicesParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get services params
func (o *GetServicesParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the get services params
func (o *GetServicesParams) WithHTTPClient(client *http.Client) *GetServicesParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the get services params
func (o *GetServicesParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithLimit adds the limit to the get services params
func (o *GetServicesParams) WithLimit(limit *int64) *GetServicesParams {
	o.SetLimit(limit)
	return o
}

// SetLimit adds the limit to the get services params
func (o *GetServicesParams) SetLimit(limit *int64) {
	o.Limit = limit
}

// WithOffset adds the offset to the get services params
func (o *GetServicesParams) WithOffset(offset *int64) *GetServicesParams {
	o.SetOffset(offset)
	return o
}

// SetOffset adds the offset to the get services params
func (o *GetServicesParams) SetOffset(offset *int64) {
	o.Offset = offset
}

// WithServiceID adds the serviceID to the get services params
func (o *GetServicesParams) WithServiceID(serviceID *string) *GetServicesParams {
	o.SetServiceID(serviceID)
	return o
}

// SetServiceID adds the serviceId to the get services params
func (o *GetServicesParams) SetServiceID(serviceID *string) {
	o.ServiceID = serviceID
}

// WriteToRequest writes these params to a swagger request
func (o *GetServicesParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.Limit != nil {

		// query param limit
		var qrLimit int64

		if o.Limit != nil {
			qrLimit = *o.Limit
		}
		qLimit := swag.FormatInt64(qrLimit)
		if qLimit != "" {

			if err := r.SetQueryParam("limit", qLimit); err != nil {
				return err
			}
		}
	}

	if o.Offset != nil {

		// query param offset
		var qrOffset int64

		if o.Offset != nil {
			qrOffset = *o.Offset
		}
		qOffset := swag.FormatInt64(qrOffset)
		if qOffset != "" {

			if err := r.SetQueryParam("offset", qOffset); err != nil {
				return err
			}
		}
	}

	if o.ServiceID != nil {

		// query param serviceId
		var qrServiceID string

		if o.ServiceID != nil {
			qrServiceID = *o.ServiceID
		}
		qServiceID := qrServiceID
		if qServiceID != "" {

			if err := r.SetQueryParam("serviceId", qServiceID); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
