// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Telnexus LLC
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package service

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/telnexus/lib/api/devops/devops_models"
)

// NewPutServicesParams creates a new PutServicesParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewPutServicesParams() *PutServicesParams {
	return &PutServicesParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewPutServicesParamsWithTimeout creates a new PutServicesParams object
// with the ability to set a timeout on a request.
func NewPutServicesParamsWithTimeout(timeout time.Duration) *PutServicesParams {
	return &PutServicesParams{
		timeout: timeout,
	}
}

// NewPutServicesParamsWithContext creates a new PutServicesParams object
// with the ability to set a context for a request.
func NewPutServicesParamsWithContext(ctx context.Context) *PutServicesParams {
	return &PutServicesParams{
		Context: ctx,
	}
}

// NewPutServicesParamsWithHTTPClient creates a new PutServicesParams object
// with the ability to set a custom HTTPClient for a request.
func NewPutServicesParamsWithHTTPClient(client *http.Client) *PutServicesParams {
	return &PutServicesParams{
		HTTPClient: client,
	}
}

/* PutServicesParams contains all the parameters to send to the API endpoint
   for the put services operation.

   Typically these are written to a http.Request.
*/
type PutServicesParams struct {

	/* ServiceRequest.

	   An array of Service records
	*/
	ServiceRequest *devops_models.ServiceRequest

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the put services params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PutServicesParams) WithDefaults() *PutServicesParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the put services params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PutServicesParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the put services params
func (o *PutServicesParams) WithTimeout(timeout time.Duration) *PutServicesParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the put services params
func (o *PutServicesParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the put services params
func (o *PutServicesParams) WithContext(ctx context.Context) *PutServicesParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the put services params
func (o *PutServicesParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the put services params
func (o *PutServicesParams) WithHTTPClient(client *http.Client) *PutServicesParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the put services params
func (o *PutServicesParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithServiceRequest adds the serviceRequest to the put services params
func (o *PutServicesParams) WithServiceRequest(serviceRequest *devops_models.ServiceRequest) *PutServicesParams {
	o.SetServiceRequest(serviceRequest)
	return o
}

// SetServiceRequest adds the serviceRequest to the put services params
func (o *PutServicesParams) SetServiceRequest(serviceRequest *devops_models.ServiceRequest) {
	o.ServiceRequest = serviceRequest
}

// WriteToRequest writes these params to a swagger request
func (o *PutServicesParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.ServiceRequest != nil {
		if err := r.SetBodyParam(o.ServiceRequest); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
