// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Telnexus LLC
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package template

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/telnexus/lib/api/devops/devops_models"
)

// GetTemplatesReader is a Reader for the GetTemplates structure.
type GetTemplatesReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetTemplatesReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetTemplatesOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewGetTemplatesUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewGetTemplatesForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewGetTemplatesNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewGetTemplatesUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewGetTemplatesInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		return nil, runtime.NewAPIError("response status code does not match any response statuses defined for this endpoint in the swagger spec", response, response.Code())
	}
}

// NewGetTemplatesOK creates a GetTemplatesOK with default headers values
func NewGetTemplatesOK() *GetTemplatesOK {
	return &GetTemplatesOK{}
}

/* GetTemplatesOK describes a response with status code 200, with default header values.

Telnexus Response with Template objects
*/
type GetTemplatesOK struct {
	AccessControlAllowOrigin string
	CacheControl             string

	Payload *devops_models.TemplateResponse
}

func (o *GetTemplatesOK) Error() string {
	return fmt.Sprintf("[GET /templates][%d] getTemplatesOK  %+v", 200, o.Payload)
}
func (o *GetTemplatesOK) GetPayload() *devops_models.TemplateResponse {
	return o.Payload
}

func (o *GetTemplatesOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	// hydrates response header Cache-Control
	hdrCacheControl := response.GetHeader("Cache-Control")

	if hdrCacheControl != "" {
		o.CacheControl = hdrCacheControl
	}

	o.Payload = new(devops_models.TemplateResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetTemplatesUnauthorized creates a GetTemplatesUnauthorized with default headers values
func NewGetTemplatesUnauthorized() *GetTemplatesUnauthorized {
	return &GetTemplatesUnauthorized{}
}

/* GetTemplatesUnauthorized describes a response with status code 401, with default header values.

Access Unauthorized, invalid API-KEY was used
*/
type GetTemplatesUnauthorized struct {
	AccessControlAllowOrigin string
	CacheControl             string

	Payload *devops_models.Error
}

func (o *GetTemplatesUnauthorized) Error() string {
	return fmt.Sprintf("[GET /templates][%d] getTemplatesUnauthorized  %+v", 401, o.Payload)
}
func (o *GetTemplatesUnauthorized) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *GetTemplatesUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	// hydrates response header Cache-Control
	hdrCacheControl := response.GetHeader("Cache-Control")

	if hdrCacheControl != "" {
		o.CacheControl = hdrCacheControl
	}

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetTemplatesForbidden creates a GetTemplatesForbidden with default headers values
func NewGetTemplatesForbidden() *GetTemplatesForbidden {
	return &GetTemplatesForbidden{}
}

/* GetTemplatesForbidden describes a response with status code 403, with default header values.

Access forbidden, account lacks access
*/
type GetTemplatesForbidden struct {
	AccessControlAllowOrigin string

	Payload *devops_models.Error
}

func (o *GetTemplatesForbidden) Error() string {
	return fmt.Sprintf("[GET /templates][%d] getTemplatesForbidden  %+v", 403, o.Payload)
}
func (o *GetTemplatesForbidden) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *GetTemplatesForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetTemplatesNotFound creates a GetTemplatesNotFound with default headers values
func NewGetTemplatesNotFound() *GetTemplatesNotFound {
	return &GetTemplatesNotFound{}
}

/* GetTemplatesNotFound describes a response with status code 404, with default header values.

Resource was not found
*/
type GetTemplatesNotFound struct {
	AccessControlAllowOrigin string

	Payload *devops_models.Error
}

func (o *GetTemplatesNotFound) Error() string {
	return fmt.Sprintf("[GET /templates][%d] getTemplatesNotFound  %+v", 404, o.Payload)
}
func (o *GetTemplatesNotFound) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *GetTemplatesNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetTemplatesUnprocessableEntity creates a GetTemplatesUnprocessableEntity with default headers values
func NewGetTemplatesUnprocessableEntity() *GetTemplatesUnprocessableEntity {
	return &GetTemplatesUnprocessableEntity{}
}

/* GetTemplatesUnprocessableEntity describes a response with status code 422, with default header values.

Unprocessable Entity, likely a bad parameter
*/
type GetTemplatesUnprocessableEntity struct {
	AccessControlAllowOrigin string
	CacheControl             string

	Payload *devops_models.Error
}

func (o *GetTemplatesUnprocessableEntity) Error() string {
	return fmt.Sprintf("[GET /templates][%d] getTemplatesUnprocessableEntity  %+v", 422, o.Payload)
}
func (o *GetTemplatesUnprocessableEntity) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *GetTemplatesUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	// hydrates response header Cache-Control
	hdrCacheControl := response.GetHeader("Cache-Control")

	if hdrCacheControl != "" {
		o.CacheControl = hdrCacheControl
	}

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetTemplatesInternalServerError creates a GetTemplatesInternalServerError with default headers values
func NewGetTemplatesInternalServerError() *GetTemplatesInternalServerError {
	return &GetTemplatesInternalServerError{}
}

/* GetTemplatesInternalServerError describes a response with status code 500, with default header values.

Server Internal Error
*/
type GetTemplatesInternalServerError struct {
	AccessControlAllowOrigin string

	Payload *devops_models.Error
}

func (o *GetTemplatesInternalServerError) Error() string {
	return fmt.Sprintf("[GET /templates][%d] getTemplatesInternalServerError  %+v", 500, o.Payload)
}
func (o *GetTemplatesInternalServerError) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *GetTemplatesInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
