// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Telnexus LLC
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package tenant

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/telnexus/lib/api/devops/devops_models"
)

// GetTenantsObservableReader is a Reader for the GetTenantsObservable structure.
type GetTenantsObservableReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetTenantsObservableReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetTenantsObservableOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewGetTenantsObservableUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewGetTenantsObservableForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewGetTenantsObservableNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewGetTenantsObservableUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewGetTenantsObservableInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		return nil, runtime.NewAPIError("response status code does not match any response statuses defined for this endpoint in the swagger spec", response, response.Code())
	}
}

// NewGetTenantsObservableOK creates a GetTenantsObservableOK with default headers values
func NewGetTenantsObservableOK() *GetTenantsObservableOK {
	return &GetTenantsObservableOK{}
}

/* GetTenantsObservableOK describes a response with status code 200, with default header values.

Single Tenant record response
*/
type GetTenantsObservableOK struct {
	AccessControlAllowOrigin string
	CacheControl             string

	Payload []*devops_models.Tenant
}

func (o *GetTenantsObservableOK) Error() string {
	return fmt.Sprintf("[GET /tenants/observable][%d] getTenantsObservableOK  %+v", 200, o.Payload)
}
func (o *GetTenantsObservableOK) GetPayload() []*devops_models.Tenant {
	return o.Payload
}

func (o *GetTenantsObservableOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	// hydrates response header Cache-Control
	hdrCacheControl := response.GetHeader("Cache-Control")

	if hdrCacheControl != "" {
		o.CacheControl = hdrCacheControl
	}

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetTenantsObservableUnauthorized creates a GetTenantsObservableUnauthorized with default headers values
func NewGetTenantsObservableUnauthorized() *GetTenantsObservableUnauthorized {
	return &GetTenantsObservableUnauthorized{}
}

/* GetTenantsObservableUnauthorized describes a response with status code 401, with default header values.

Access Unauthorized, invalid API-KEY was used
*/
type GetTenantsObservableUnauthorized struct {
	AccessControlAllowOrigin string
	CacheControl             string

	Payload *devops_models.Error
}

func (o *GetTenantsObservableUnauthorized) Error() string {
	return fmt.Sprintf("[GET /tenants/observable][%d] getTenantsObservableUnauthorized  %+v", 401, o.Payload)
}
func (o *GetTenantsObservableUnauthorized) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *GetTenantsObservableUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	// hydrates response header Cache-Control
	hdrCacheControl := response.GetHeader("Cache-Control")

	if hdrCacheControl != "" {
		o.CacheControl = hdrCacheControl
	}

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetTenantsObservableForbidden creates a GetTenantsObservableForbidden with default headers values
func NewGetTenantsObservableForbidden() *GetTenantsObservableForbidden {
	return &GetTenantsObservableForbidden{}
}

/* GetTenantsObservableForbidden describes a response with status code 403, with default header values.

Access forbidden, account lacks access
*/
type GetTenantsObservableForbidden struct {
	AccessControlAllowOrigin string

	Payload *devops_models.Error
}

func (o *GetTenantsObservableForbidden) Error() string {
	return fmt.Sprintf("[GET /tenants/observable][%d] getTenantsObservableForbidden  %+v", 403, o.Payload)
}
func (o *GetTenantsObservableForbidden) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *GetTenantsObservableForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetTenantsObservableNotFound creates a GetTenantsObservableNotFound with default headers values
func NewGetTenantsObservableNotFound() *GetTenantsObservableNotFound {
	return &GetTenantsObservableNotFound{}
}

/* GetTenantsObservableNotFound describes a response with status code 404, with default header values.

Resource was not found
*/
type GetTenantsObservableNotFound struct {
	AccessControlAllowOrigin string

	Payload *devops_models.Error
}

func (o *GetTenantsObservableNotFound) Error() string {
	return fmt.Sprintf("[GET /tenants/observable][%d] getTenantsObservableNotFound  %+v", 404, o.Payload)
}
func (o *GetTenantsObservableNotFound) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *GetTenantsObservableNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetTenantsObservableUnprocessableEntity creates a GetTenantsObservableUnprocessableEntity with default headers values
func NewGetTenantsObservableUnprocessableEntity() *GetTenantsObservableUnprocessableEntity {
	return &GetTenantsObservableUnprocessableEntity{}
}

/* GetTenantsObservableUnprocessableEntity describes a response with status code 422, with default header values.

Unprocessable Entity, likely a bad parameter
*/
type GetTenantsObservableUnprocessableEntity struct {
	AccessControlAllowOrigin string
	CacheControl             string

	Payload *devops_models.Error
}

func (o *GetTenantsObservableUnprocessableEntity) Error() string {
	return fmt.Sprintf("[GET /tenants/observable][%d] getTenantsObservableUnprocessableEntity  %+v", 422, o.Payload)
}
func (o *GetTenantsObservableUnprocessableEntity) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *GetTenantsObservableUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	// hydrates response header Cache-Control
	hdrCacheControl := response.GetHeader("Cache-Control")

	if hdrCacheControl != "" {
		o.CacheControl = hdrCacheControl
	}

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetTenantsObservableInternalServerError creates a GetTenantsObservableInternalServerError with default headers values
func NewGetTenantsObservableInternalServerError() *GetTenantsObservableInternalServerError {
	return &GetTenantsObservableInternalServerError{}
}

/* GetTenantsObservableInternalServerError describes a response with status code 500, with default header values.

Server Internal Error
*/
type GetTenantsObservableInternalServerError struct {
	AccessControlAllowOrigin string

	Payload *devops_models.Error
}

func (o *GetTenantsObservableInternalServerError) Error() string {
	return fmt.Sprintf("[GET /tenants/observable][%d] getTenantsObservableInternalServerError  %+v", 500, o.Payload)
}
func (o *GetTenantsObservableInternalServerError) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *GetTenantsObservableInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
