// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Telnexus LLC
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package zone

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewGetZonesParams creates a new GetZonesParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewGetZonesParams() *GetZonesParams {
	return &GetZonesParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewGetZonesParamsWithTimeout creates a new GetZonesParams object
// with the ability to set a timeout on a request.
func NewGetZonesParamsWithTimeout(timeout time.Duration) *GetZonesParams {
	return &GetZonesParams{
		timeout: timeout,
	}
}

// NewGetZonesParamsWithContext creates a new GetZonesParams object
// with the ability to set a context for a request.
func NewGetZonesParamsWithContext(ctx context.Context) *GetZonesParams {
	return &GetZonesParams{
		Context: ctx,
	}
}

// NewGetZonesParamsWithHTTPClient creates a new GetZonesParams object
// with the ability to set a custom HTTPClient for a request.
func NewGetZonesParamsWithHTTPClient(client *http.Client) *GetZonesParams {
	return &GetZonesParams{
		HTTPClient: client,
	}
}

/* GetZonesParams contains all the parameters to send to the API endpoint
   for the get zones operation.

   Typically these are written to a http.Request.
*/
type GetZonesParams struct {

	/* Limit.

	   How many objects to return at one time (max 300, default 100)

	   Format: int64
	   Default: 100
	*/
	Limit *int64

	/* Offset.

	   How many objects to skip? (default 0)

	   Format: int64
	*/
	Offset *int64

	/* ZoneID.

	   Telnexus Record Id of a Zone
	*/
	ZoneID *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the get zones params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetZonesParams) WithDefaults() *GetZonesParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the get zones params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetZonesParams) SetDefaults() {
	var (
		limitDefault = int64(100)

		offsetDefault = int64(0)
	)

	val := GetZonesParams{
		Limit:  &limitDefault,
		Offset: &offsetDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the get zones params
func (o *GetZonesParams) WithTimeout(timeout time.Duration) *GetZonesParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get zones params
func (o *GetZonesParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get zones params
func (o *GetZonesParams) WithContext(ctx context.Context) *GetZonesParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get zones params
func (o *GetZonesParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the get zones params
func (o *GetZonesParams) WithHTTPClient(client *http.Client) *GetZonesParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the get zones params
func (o *GetZonesParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithLimit adds the limit to the get zones params
func (o *GetZonesParams) WithLimit(limit *int64) *GetZonesParams {
	o.SetLimit(limit)
	return o
}

// SetLimit adds the limit to the get zones params
func (o *GetZonesParams) SetLimit(limit *int64) {
	o.Limit = limit
}

// WithOffset adds the offset to the get zones params
func (o *GetZonesParams) WithOffset(offset *int64) *GetZonesParams {
	o.SetOffset(offset)
	return o
}

// SetOffset adds the offset to the get zones params
func (o *GetZonesParams) SetOffset(offset *int64) {
	o.Offset = offset
}

// WithZoneID adds the zoneID to the get zones params
func (o *GetZonesParams) WithZoneID(zoneID *string) *GetZonesParams {
	o.SetZoneID(zoneID)
	return o
}

// SetZoneID adds the zoneId to the get zones params
func (o *GetZonesParams) SetZoneID(zoneID *string) {
	o.ZoneID = zoneID
}

// WriteToRequest writes these params to a swagger request
func (o *GetZonesParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.Limit != nil {

		// query param limit
		var qrLimit int64

		if o.Limit != nil {
			qrLimit = *o.Limit
		}
		qLimit := swag.FormatInt64(qrLimit)
		if qLimit != "" {

			if err := r.SetQueryParam("limit", qLimit); err != nil {
				return err
			}
		}
	}

	if o.Offset != nil {

		// query param offset
		var qrOffset int64

		if o.Offset != nil {
			qrOffset = *o.Offset
		}
		qOffset := swag.FormatInt64(qrOffset)
		if qOffset != "" {

			if err := r.SetQueryParam("offset", qOffset); err != nil {
				return err
			}
		}
	}

	if o.ZoneID != nil {

		// query param zoneId
		var qrZoneID string

		if o.ZoneID != nil {
			qrZoneID = *o.ZoneID
		}
		qZoneID := qrZoneID
		if qZoneID != "" {

			if err := r.SetQueryParam("zoneId", qZoneID); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
