// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Telnexus LLC
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package device

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
)

// New creates a new device API client.
func New(transport runtime.ClientTransport, formats strfmt.Registry) ClientService {
	return &Client{transport: transport, formats: formats}
}

/*
Client for device API
*/
type Client struct {
	transport runtime.ClientTransport
	formats   strfmt.Registry
}

// ClientOption is the option for Client methods
type ClientOption func(*runtime.ClientOperation)

// ClientService is the interface for Client methods
type ClientService interface {
	GetAccountDevices(params *GetAccountDevicesParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*GetAccountDevicesOK, error)

	GetUserDevices(params *GetUserDevicesParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*GetUserDevicesOK, error)

	SetTransport(transport runtime.ClientTransport)
}

/*
  GetAccountDevices get account devices API
*/
func (a *Client) GetAccountDevices(params *GetAccountDevicesParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*GetAccountDevicesOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewGetAccountDevicesParams()
	}
	op := &runtime.ClientOperation{
		ID:                 "getAccountDevices",
		Method:             "GET",
		PathPattern:        "/accounts/{accountId}/devices",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"https"},
		Params:             params,
		Reader:             &GetAccountDevicesReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	}
	for _, opt := range opts {
		opt(op)
	}

	result, err := a.transport.Submit(op)
	if err != nil {
		return nil, err
	}
	success, ok := result.(*GetAccountDevicesOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for getAccountDevices: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

/*
  GetUserDevices get user devices API
*/
func (a *Client) GetUserDevices(params *GetUserDevicesParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*GetUserDevicesOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewGetUserDevicesParams()
	}
	op := &runtime.ClientOperation{
		ID:                 "getUserDevices",
		Method:             "GET",
		PathPattern:        "/accounts/{accountId}/users/{userId}/devices",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"https"},
		Params:             params,
		Reader:             &GetUserDevicesReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	}
	for _, opt := range opts {
		opt(op)
	}

	result, err := a.transport.Submit(op)
	if err != nil {
		return nil, err
	}
	success, ok := result.(*GetUserDevicesOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for getUserDevices: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

// SetTransport changes the transport on the client
func (a *Client) SetTransport(transport runtime.ClientTransport) {
	a.transport = transport
}
