// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Telnexus LLC
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package stash_pdf

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/telnexus/lib/api/stash/stash_models"
)

// NewPostPdfsParams creates a new PostPdfsParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewPostPdfsParams() *PostPdfsParams {
	return &PostPdfsParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewPostPdfsParamsWithTimeout creates a new PostPdfsParams object
// with the ability to set a timeout on a request.
func NewPostPdfsParamsWithTimeout(timeout time.Duration) *PostPdfsParams {
	return &PostPdfsParams{
		timeout: timeout,
	}
}

// NewPostPdfsParamsWithContext creates a new PostPdfsParams object
// with the ability to set a context for a request.
func NewPostPdfsParamsWithContext(ctx context.Context) *PostPdfsParams {
	return &PostPdfsParams{
		Context: ctx,
	}
}

// NewPostPdfsParamsWithHTTPClient creates a new PostPdfsParams object
// with the ability to set a custom HTTPClient for a request.
func NewPostPdfsParamsWithHTTPClient(client *http.Client) *PostPdfsParams {
	return &PostPdfsParams{
		HTTPClient: client,
	}
}

/* PostPdfsParams contains all the parameters to send to the API endpoint
   for the post pdfs operation.

   Typically these are written to a http.Request.
*/
type PostPdfsParams struct {

	/* PDFRequest.

	   An array of new PDF records
	*/
	PDFRequest *stash_models.PDFRequest

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the post pdfs params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PostPdfsParams) WithDefaults() *PostPdfsParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the post pdfs params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PostPdfsParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the post pdfs params
func (o *PostPdfsParams) WithTimeout(timeout time.Duration) *PostPdfsParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the post pdfs params
func (o *PostPdfsParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the post pdfs params
func (o *PostPdfsParams) WithContext(ctx context.Context) *PostPdfsParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the post pdfs params
func (o *PostPdfsParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the post pdfs params
func (o *PostPdfsParams) WithHTTPClient(client *http.Client) *PostPdfsParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the post pdfs params
func (o *PostPdfsParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithPDFRequest adds the pDFRequest to the post pdfs params
func (o *PostPdfsParams) WithPDFRequest(pDFRequest *stash_models.PDFRequest) *PostPdfsParams {
	o.SetPDFRequest(pDFRequest)
	return o
}

// SetPDFRequest adds the pDFRequest to the post pdfs params
func (o *PostPdfsParams) SetPDFRequest(pDFRequest *stash_models.PDFRequest) {
	o.PDFRequest = pDFRequest
}

// WriteToRequest writes these params to a swagger request
func (o *PostPdfsParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.PDFRequest != nil {
		if err := r.SetBodyParam(o.PDFRequest); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
