// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Telnexus LLC
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package authority

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/telnexus/lib/api/voip/voip_models"
)

// NewPostAuthoritiesParams creates a new PostAuthoritiesParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewPostAuthoritiesParams() *PostAuthoritiesParams {
	return &PostAuthoritiesParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewPostAuthoritiesParamsWithTimeout creates a new PostAuthoritiesParams object
// with the ability to set a timeout on a request.
func NewPostAuthoritiesParamsWithTimeout(timeout time.Duration) *PostAuthoritiesParams {
	return &PostAuthoritiesParams{
		timeout: timeout,
	}
}

// NewPostAuthoritiesParamsWithContext creates a new PostAuthoritiesParams object
// with the ability to set a context for a request.
func NewPostAuthoritiesParamsWithContext(ctx context.Context) *PostAuthoritiesParams {
	return &PostAuthoritiesParams{
		Context: ctx,
	}
}

// NewPostAuthoritiesParamsWithHTTPClient creates a new PostAuthoritiesParams object
// with the ability to set a custom HTTPClient for a request.
func NewPostAuthoritiesParamsWithHTTPClient(client *http.Client) *PostAuthoritiesParams {
	return &PostAuthoritiesParams{
		HTTPClient: client,
	}
}

/* PostAuthoritiesParams contains all the parameters to send to the API endpoint
   for the post authorities operation.

   Typically these are written to a http.Request.
*/
type PostAuthoritiesParams struct {

	/* AuthorityRequest.

	   A request with an array of Authority Objects
	*/
	AuthorityRequest *voip_models.AuthorityRequest

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the post authorities params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PostAuthoritiesParams) WithDefaults() *PostAuthoritiesParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the post authorities params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PostAuthoritiesParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the post authorities params
func (o *PostAuthoritiesParams) WithTimeout(timeout time.Duration) *PostAuthoritiesParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the post authorities params
func (o *PostAuthoritiesParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the post authorities params
func (o *PostAuthoritiesParams) WithContext(ctx context.Context) *PostAuthoritiesParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the post authorities params
func (o *PostAuthoritiesParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the post authorities params
func (o *PostAuthoritiesParams) WithHTTPClient(client *http.Client) *PostAuthoritiesParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the post authorities params
func (o *PostAuthoritiesParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithAuthorityRequest adds the authorityRequest to the post authorities params
func (o *PostAuthoritiesParams) WithAuthorityRequest(authorityRequest *voip_models.AuthorityRequest) *PostAuthoritiesParams {
	o.SetAuthorityRequest(authorityRequest)
	return o
}

// SetAuthorityRequest adds the authorityRequest to the post authorities params
func (o *PostAuthoritiesParams) SetAuthorityRequest(authorityRequest *voip_models.AuthorityRequest) {
	o.AuthorityRequest = authorityRequest
}

// WriteToRequest writes these params to a swagger request
func (o *PostAuthoritiesParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.AuthorityRequest != nil {
		if err := r.SetBodyParam(o.AuthorityRequest); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
