// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Telnexus LLC
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package endpoint

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/telnexus/lib/api/voip/voip_models"
)

// NewPostEndpointsParams creates a new PostEndpointsParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewPostEndpointsParams() *PostEndpointsParams {
	return &PostEndpointsParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewPostEndpointsParamsWithTimeout creates a new PostEndpointsParams object
// with the ability to set a timeout on a request.
func NewPostEndpointsParamsWithTimeout(timeout time.Duration) *PostEndpointsParams {
	return &PostEndpointsParams{
		timeout: timeout,
	}
}

// NewPostEndpointsParamsWithContext creates a new PostEndpointsParams object
// with the ability to set a context for a request.
func NewPostEndpointsParamsWithContext(ctx context.Context) *PostEndpointsParams {
	return &PostEndpointsParams{
		Context: ctx,
	}
}

// NewPostEndpointsParamsWithHTTPClient creates a new PostEndpointsParams object
// with the ability to set a custom HTTPClient for a request.
func NewPostEndpointsParamsWithHTTPClient(client *http.Client) *PostEndpointsParams {
	return &PostEndpointsParams{
		HTTPClient: client,
	}
}

/* PostEndpointsParams contains all the parameters to send to the API endpoint
   for the post endpoints operation.

   Typically these are written to a http.Request.
*/
type PostEndpointsParams struct {

	/* EndpointRequest.

	   An array of new PBX records
	*/
	EndpointRequest *voip_models.EndpointRequest

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the post endpoints params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PostEndpointsParams) WithDefaults() *PostEndpointsParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the post endpoints params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PostEndpointsParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the post endpoints params
func (o *PostEndpointsParams) WithTimeout(timeout time.Duration) *PostEndpointsParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the post endpoints params
func (o *PostEndpointsParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the post endpoints params
func (o *PostEndpointsParams) WithContext(ctx context.Context) *PostEndpointsParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the post endpoints params
func (o *PostEndpointsParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the post endpoints params
func (o *PostEndpointsParams) WithHTTPClient(client *http.Client) *PostEndpointsParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the post endpoints params
func (o *PostEndpointsParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithEndpointRequest adds the endpointRequest to the post endpoints params
func (o *PostEndpointsParams) WithEndpointRequest(endpointRequest *voip_models.EndpointRequest) *PostEndpointsParams {
	o.SetEndpointRequest(endpointRequest)
	return o
}

// SetEndpointRequest adds the endpointRequest to the post endpoints params
func (o *PostEndpointsParams) SetEndpointRequest(endpointRequest *voip_models.EndpointRequest) {
	o.EndpointRequest = endpointRequest
}

// WriteToRequest writes these params to a swagger request
func (o *PostEndpointsParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.EndpointRequest != nil {
		if err := r.SetBodyParam(o.EndpointRequest); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
