// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Telnexus LLC
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package pbx

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
)

// New creates a new pbx API client.
func New(transport runtime.ClientTransport, formats strfmt.Registry) ClientService {
	return &Client{transport: transport, formats: formats}
}

/*
Client for pbx API
*/
type Client struct {
	transport runtime.ClientTransport
	formats   strfmt.Registry
}

// ClientOption is the option for Client methods
type ClientOption func(*runtime.ClientOperation)

// ClientService is the interface for Client methods
type ClientService interface {
	GetPBXes(params *GetPBXesParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*GetPBXesOK, error)

	PostPBXes(params *PostPBXesParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*PostPBXesOK, error)

	PutPBXes(params *PutPBXesParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*PutPBXesOK, error)

	SetTransport(transport runtime.ClientTransport)
}

/*
  GetPBXes gets a list of p b xes

  Return a list of available PBX entities
*/
func (a *Client) GetPBXes(params *GetPBXesParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*GetPBXesOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewGetPBXesParams()
	}
	op := &runtime.ClientOperation{
		ID:                 "getPBXes",
		Method:             "GET",
		PathPattern:        "/pbxes",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &GetPBXesReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	}
	for _, opt := range opts {
		opt(op)
	}

	result, err := a.transport.Submit(op)
	if err != nil {
		return nil, err
	}
	success, ok := result.(*GetPBXesOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for getPBXes: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

/*
  PostPBXes adds new p b xes

  Create new PBXes
*/
func (a *Client) PostPBXes(params *PostPBXesParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*PostPBXesOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewPostPBXesParams()
	}
	op := &runtime.ClientOperation{
		ID:                 "postPBXes",
		Method:             "POST",
		PathPattern:        "/pbxes",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &PostPBXesReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	}
	for _, opt := range opts {
		opt(op)
	}

	result, err := a.transport.Submit(op)
	if err != nil {
		return nil, err
	}
	success, ok := result.(*PostPBXesOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for postPBXes: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

/*
  PutPBXes updates p b xes

  Update fields in an PBX record identified by Telnexus Id
*/
func (a *Client) PutPBXes(params *PutPBXesParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*PutPBXesOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewPutPBXesParams()
	}
	op := &runtime.ClientOperation{
		ID:                 "putPBXes",
		Method:             "PUT",
		PathPattern:        "/pbxes",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &PutPBXesReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	}
	for _, opt := range opts {
		opt(op)
	}

	result, err := a.transport.Submit(op)
	if err != nil {
		return nil, err
	}
	success, ok := result.(*PutPBXesOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for putPBXes: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

// SetTransport changes the transport on the client
func (a *Client) SetTransport(transport runtime.ClientTransport) {
	a.transport = transport
}
