// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Telnexus LLC
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package pbx

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/telnexus/lib/api/voip/voip_models"
)

// PostPBXesReader is a Reader for the PostPBXes structure.
type PostPBXesReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *PostPBXesReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewPostPBXesOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewPostPBXesUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewPostPBXesForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewPostPBXesNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewPostPBXesUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewPostPBXesInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		return nil, runtime.NewAPIError("response status code does not match any response statuses defined for this endpoint in the swagger spec", response, response.Code())
	}
}

// NewPostPBXesOK creates a PostPBXesOK with default headers values
func NewPostPBXesOK() *PostPBXesOK {
	return &PostPBXesOK{}
}

/* PostPBXesOK describes a response with status code 200, with default header values.

Telnexus Response with an array of PBX objects
*/
type PostPBXesOK struct {
	Payload *voip_models.PbxResponse
}

func (o *PostPBXesOK) Error() string {
	return fmt.Sprintf("[POST /pbxes][%d] postPBXesOK  %+v", 200, o.Payload)
}
func (o *PostPBXesOK) GetPayload() *voip_models.PbxResponse {
	return o.Payload
}

func (o *PostPBXesOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(voip_models.PbxResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostPBXesUnauthorized creates a PostPBXesUnauthorized with default headers values
func NewPostPBXesUnauthorized() *PostPBXesUnauthorized {
	return &PostPBXesUnauthorized{}
}

/* PostPBXesUnauthorized describes a response with status code 401, with default header values.

Access Unauthorized, invalid API-KEY was used
*/
type PostPBXesUnauthorized struct {
	Payload *voip_models.Error
}

func (o *PostPBXesUnauthorized) Error() string {
	return fmt.Sprintf("[POST /pbxes][%d] postPBXesUnauthorized  %+v", 401, o.Payload)
}
func (o *PostPBXesUnauthorized) GetPayload() *voip_models.Error {
	return o.Payload
}

func (o *PostPBXesUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(voip_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostPBXesForbidden creates a PostPBXesForbidden with default headers values
func NewPostPBXesForbidden() *PostPBXesForbidden {
	return &PostPBXesForbidden{}
}

/* PostPBXesForbidden describes a response with status code 403, with default header values.

Access forbidden, account lacks access
*/
type PostPBXesForbidden struct {
	Payload *voip_models.Error
}

func (o *PostPBXesForbidden) Error() string {
	return fmt.Sprintf("[POST /pbxes][%d] postPBXesForbidden  %+v", 403, o.Payload)
}
func (o *PostPBXesForbidden) GetPayload() *voip_models.Error {
	return o.Payload
}

func (o *PostPBXesForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(voip_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostPBXesNotFound creates a PostPBXesNotFound with default headers values
func NewPostPBXesNotFound() *PostPBXesNotFound {
	return &PostPBXesNotFound{}
}

/* PostPBXesNotFound describes a response with status code 404, with default header values.

Resource was not found
*/
type PostPBXesNotFound struct {
	Payload *voip_models.Error
}

func (o *PostPBXesNotFound) Error() string {
	return fmt.Sprintf("[POST /pbxes][%d] postPBXesNotFound  %+v", 404, o.Payload)
}
func (o *PostPBXesNotFound) GetPayload() *voip_models.Error {
	return o.Payload
}

func (o *PostPBXesNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(voip_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostPBXesUnprocessableEntity creates a PostPBXesUnprocessableEntity with default headers values
func NewPostPBXesUnprocessableEntity() *PostPBXesUnprocessableEntity {
	return &PostPBXesUnprocessableEntity{}
}

/* PostPBXesUnprocessableEntity describes a response with status code 422, with default header values.

Unprocessable Entity, likely a bad parameter
*/
type PostPBXesUnprocessableEntity struct {
	Payload *voip_models.Error
}

func (o *PostPBXesUnprocessableEntity) Error() string {
	return fmt.Sprintf("[POST /pbxes][%d] postPBXesUnprocessableEntity  %+v", 422, o.Payload)
}
func (o *PostPBXesUnprocessableEntity) GetPayload() *voip_models.Error {
	return o.Payload
}

func (o *PostPBXesUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(voip_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostPBXesInternalServerError creates a PostPBXesInternalServerError with default headers values
func NewPostPBXesInternalServerError() *PostPBXesInternalServerError {
	return &PostPBXesInternalServerError{}
}

/* PostPBXesInternalServerError describes a response with status code 500, with default header values.

Server Internal Error
*/
type PostPBXesInternalServerError struct {
	Payload *voip_models.Error
}

func (o *PostPBXesInternalServerError) Error() string {
	return fmt.Sprintf("[POST /pbxes][%d] postPBXesInternalServerError  %+v", 500, o.Payload)
}
func (o *PostPBXesInternalServerError) GetPayload() *voip_models.Error {
	return o.Payload
}

func (o *PostPBXesInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(voip_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
