// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Telnexus LLC
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package pbx

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/telnexus/lib/api/voip/voip_models"
)

// PutPBXesReader is a Reader for the PutPBXes structure.
type PutPBXesReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *PutPBXesReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewPutPBXesOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewPutPBXesUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewPutPBXesForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewPutPBXesNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewPutPBXesUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewPutPBXesInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		return nil, runtime.NewAPIError("response status code does not match any response statuses defined for this endpoint in the swagger spec", response, response.Code())
	}
}

// NewPutPBXesOK creates a PutPBXesOK with default headers values
func NewPutPBXesOK() *PutPBXesOK {
	return &PutPBXesOK{}
}

/* PutPBXesOK describes a response with status code 200, with default header values.

Telnexus Response with an array of PBX objects
*/
type PutPBXesOK struct {
	Payload *voip_models.PbxResponse
}

func (o *PutPBXesOK) Error() string {
	return fmt.Sprintf("[PUT /pbxes][%d] putPBXesOK  %+v", 200, o.Payload)
}
func (o *PutPBXesOK) GetPayload() *voip_models.PbxResponse {
	return o.Payload
}

func (o *PutPBXesOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(voip_models.PbxResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutPBXesUnauthorized creates a PutPBXesUnauthorized with default headers values
func NewPutPBXesUnauthorized() *PutPBXesUnauthorized {
	return &PutPBXesUnauthorized{}
}

/* PutPBXesUnauthorized describes a response with status code 401, with default header values.

Access Unauthorized, invalid API-KEY was used
*/
type PutPBXesUnauthorized struct {
	Payload *voip_models.Error
}

func (o *PutPBXesUnauthorized) Error() string {
	return fmt.Sprintf("[PUT /pbxes][%d] putPBXesUnauthorized  %+v", 401, o.Payload)
}
func (o *PutPBXesUnauthorized) GetPayload() *voip_models.Error {
	return o.Payload
}

func (o *PutPBXesUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(voip_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutPBXesForbidden creates a PutPBXesForbidden with default headers values
func NewPutPBXesForbidden() *PutPBXesForbidden {
	return &PutPBXesForbidden{}
}

/* PutPBXesForbidden describes a response with status code 403, with default header values.

Access forbidden, account lacks access
*/
type PutPBXesForbidden struct {
	Payload *voip_models.Error
}

func (o *PutPBXesForbidden) Error() string {
	return fmt.Sprintf("[PUT /pbxes][%d] putPBXesForbidden  %+v", 403, o.Payload)
}
func (o *PutPBXesForbidden) GetPayload() *voip_models.Error {
	return o.Payload
}

func (o *PutPBXesForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(voip_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutPBXesNotFound creates a PutPBXesNotFound with default headers values
func NewPutPBXesNotFound() *PutPBXesNotFound {
	return &PutPBXesNotFound{}
}

/* PutPBXesNotFound describes a response with status code 404, with default header values.

Resource was not found
*/
type PutPBXesNotFound struct {
	Payload *voip_models.Error
}

func (o *PutPBXesNotFound) Error() string {
	return fmt.Sprintf("[PUT /pbxes][%d] putPBXesNotFound  %+v", 404, o.Payload)
}
func (o *PutPBXesNotFound) GetPayload() *voip_models.Error {
	return o.Payload
}

func (o *PutPBXesNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(voip_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutPBXesUnprocessableEntity creates a PutPBXesUnprocessableEntity with default headers values
func NewPutPBXesUnprocessableEntity() *PutPBXesUnprocessableEntity {
	return &PutPBXesUnprocessableEntity{}
}

/* PutPBXesUnprocessableEntity describes a response with status code 422, with default header values.

Unprocessable Entity, likely a bad parameter
*/
type PutPBXesUnprocessableEntity struct {
	Payload *voip_models.Error
}

func (o *PutPBXesUnprocessableEntity) Error() string {
	return fmt.Sprintf("[PUT /pbxes][%d] putPBXesUnprocessableEntity  %+v", 422, o.Payload)
}
func (o *PutPBXesUnprocessableEntity) GetPayload() *voip_models.Error {
	return o.Payload
}

func (o *PutPBXesUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(voip_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutPBXesInternalServerError creates a PutPBXesInternalServerError with default headers values
func NewPutPBXesInternalServerError() *PutPBXesInternalServerError {
	return &PutPBXesInternalServerError{}
}

/* PutPBXesInternalServerError describes a response with status code 500, with default header values.

Server Internal Error
*/
type PutPBXesInternalServerError struct {
	Payload *voip_models.Error
}

func (o *PutPBXesInternalServerError) Error() string {
	return fmt.Sprintf("[PUT /pbxes][%d] putPBXesInternalServerError  %+v", 500, o.Payload)
}
func (o *PutPBXesInternalServerError) GetPayload() *voip_models.Error {
	return o.Payload
}

func (o *PutPBXesInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(voip_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
