// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Telnexus LLC
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package pbx_user

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/telnexus/lib/api/voip/voip_models"
)

// GetPBXUsersReader is a Reader for the GetPBXUsers structure.
type GetPBXUsersReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetPBXUsersReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetPBXUsersOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewGetPBXUsersUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewGetPBXUsersForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewGetPBXUsersNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewGetPBXUsersUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewGetPBXUsersInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		return nil, runtime.NewAPIError("response status code does not match any response statuses defined for this endpoint in the swagger spec", response, response.Code())
	}
}

// NewGetPBXUsersOK creates a GetPBXUsersOK with default headers values
func NewGetPBXUsersOK() *GetPBXUsersOK {
	return &GetPBXUsersOK{}
}

/* GetPBXUsersOK describes a response with status code 200, with default header values.

Telnexus Response with an array of PBX User objects
*/
type GetPBXUsersOK struct {
	Payload *voip_models.PbxUserResponse
}

func (o *GetPBXUsersOK) Error() string {
	return fmt.Sprintf("[GET /pbxusers][%d] getPBXUsersOK  %+v", 200, o.Payload)
}
func (o *GetPBXUsersOK) GetPayload() *voip_models.PbxUserResponse {
	return o.Payload
}

func (o *GetPBXUsersOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(voip_models.PbxUserResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetPBXUsersUnauthorized creates a GetPBXUsersUnauthorized with default headers values
func NewGetPBXUsersUnauthorized() *GetPBXUsersUnauthorized {
	return &GetPBXUsersUnauthorized{}
}

/* GetPBXUsersUnauthorized describes a response with status code 401, with default header values.

Access Unauthorized, invalid API-KEY was used
*/
type GetPBXUsersUnauthorized struct {
	Payload *voip_models.Error
}

func (o *GetPBXUsersUnauthorized) Error() string {
	return fmt.Sprintf("[GET /pbxusers][%d] getPBXUsersUnauthorized  %+v", 401, o.Payload)
}
func (o *GetPBXUsersUnauthorized) GetPayload() *voip_models.Error {
	return o.Payload
}

func (o *GetPBXUsersUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(voip_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetPBXUsersForbidden creates a GetPBXUsersForbidden with default headers values
func NewGetPBXUsersForbidden() *GetPBXUsersForbidden {
	return &GetPBXUsersForbidden{}
}

/* GetPBXUsersForbidden describes a response with status code 403, with default header values.

Access forbidden, account lacks access
*/
type GetPBXUsersForbidden struct {
	Payload *voip_models.Error
}

func (o *GetPBXUsersForbidden) Error() string {
	return fmt.Sprintf("[GET /pbxusers][%d] getPBXUsersForbidden  %+v", 403, o.Payload)
}
func (o *GetPBXUsersForbidden) GetPayload() *voip_models.Error {
	return o.Payload
}

func (o *GetPBXUsersForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(voip_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetPBXUsersNotFound creates a GetPBXUsersNotFound with default headers values
func NewGetPBXUsersNotFound() *GetPBXUsersNotFound {
	return &GetPBXUsersNotFound{}
}

/* GetPBXUsersNotFound describes a response with status code 404, with default header values.

Resource was not found
*/
type GetPBXUsersNotFound struct {
	Payload *voip_models.Error
}

func (o *GetPBXUsersNotFound) Error() string {
	return fmt.Sprintf("[GET /pbxusers][%d] getPBXUsersNotFound  %+v", 404, o.Payload)
}
func (o *GetPBXUsersNotFound) GetPayload() *voip_models.Error {
	return o.Payload
}

func (o *GetPBXUsersNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(voip_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetPBXUsersUnprocessableEntity creates a GetPBXUsersUnprocessableEntity with default headers values
func NewGetPBXUsersUnprocessableEntity() *GetPBXUsersUnprocessableEntity {
	return &GetPBXUsersUnprocessableEntity{}
}

/* GetPBXUsersUnprocessableEntity describes a response with status code 422, with default header values.

Unprocessable Entity, likely a bad parameter
*/
type GetPBXUsersUnprocessableEntity struct {
	Payload *voip_models.Error
}

func (o *GetPBXUsersUnprocessableEntity) Error() string {
	return fmt.Sprintf("[GET /pbxusers][%d] getPBXUsersUnprocessableEntity  %+v", 422, o.Payload)
}
func (o *GetPBXUsersUnprocessableEntity) GetPayload() *voip_models.Error {
	return o.Payload
}

func (o *GetPBXUsersUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(voip_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetPBXUsersInternalServerError creates a GetPBXUsersInternalServerError with default headers values
func NewGetPBXUsersInternalServerError() *GetPBXUsersInternalServerError {
	return &GetPBXUsersInternalServerError{}
}

/* GetPBXUsersInternalServerError describes a response with status code 500, with default header values.

Server Internal Error
*/
type GetPBXUsersInternalServerError struct {
	Payload *voip_models.Error
}

func (o *GetPBXUsersInternalServerError) Error() string {
	return fmt.Sprintf("[GET /pbxusers][%d] getPBXUsersInternalServerError  %+v", 500, o.Payload)
}
func (o *GetPBXUsersInternalServerError) GetPayload() *voip_models.Error {
	return o.Payload
}

func (o *GetPBXUsersInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(voip_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
