// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Telnexus LLC
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package pbx_user

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/telnexus/lib/api/voip/voip_models"
)

// PBXUsersReader is a Reader for the PBXUsers structure.
type PBXUsersReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *PBXUsersReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewPBXUsersOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewPBXUsersUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewPBXUsersForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewPBXUsersNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewPBXUsersUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewPBXUsersInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		return nil, runtime.NewAPIError("response status code does not match any response statuses defined for this endpoint in the swagger spec", response, response.Code())
	}
}

// NewPBXUsersOK creates a PBXUsersOK with default headers values
func NewPBXUsersOK() *PBXUsersOK {
	return &PBXUsersOK{}
}

/* PBXUsersOK describes a response with status code 200, with default header values.

Telnexus Response with an array of PBX User objects
*/
type PBXUsersOK struct {
	Payload *voip_models.PbxUserResponse
}

func (o *PBXUsersOK) Error() string {
	return fmt.Sprintf("[PUT /pbxusers][%d] pBXUsersOK  %+v", 200, o.Payload)
}
func (o *PBXUsersOK) GetPayload() *voip_models.PbxUserResponse {
	return o.Payload
}

func (o *PBXUsersOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(voip_models.PbxUserResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPBXUsersUnauthorized creates a PBXUsersUnauthorized with default headers values
func NewPBXUsersUnauthorized() *PBXUsersUnauthorized {
	return &PBXUsersUnauthorized{}
}

/* PBXUsersUnauthorized describes a response with status code 401, with default header values.

Access Unauthorized, invalid API-KEY was used
*/
type PBXUsersUnauthorized struct {
	Payload *voip_models.Error
}

func (o *PBXUsersUnauthorized) Error() string {
	return fmt.Sprintf("[PUT /pbxusers][%d] pBXUsersUnauthorized  %+v", 401, o.Payload)
}
func (o *PBXUsersUnauthorized) GetPayload() *voip_models.Error {
	return o.Payload
}

func (o *PBXUsersUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(voip_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPBXUsersForbidden creates a PBXUsersForbidden with default headers values
func NewPBXUsersForbidden() *PBXUsersForbidden {
	return &PBXUsersForbidden{}
}

/* PBXUsersForbidden describes a response with status code 403, with default header values.

Access forbidden, account lacks access
*/
type PBXUsersForbidden struct {
	Payload *voip_models.Error
}

func (o *PBXUsersForbidden) Error() string {
	return fmt.Sprintf("[PUT /pbxusers][%d] pBXUsersForbidden  %+v", 403, o.Payload)
}
func (o *PBXUsersForbidden) GetPayload() *voip_models.Error {
	return o.Payload
}

func (o *PBXUsersForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(voip_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPBXUsersNotFound creates a PBXUsersNotFound with default headers values
func NewPBXUsersNotFound() *PBXUsersNotFound {
	return &PBXUsersNotFound{}
}

/* PBXUsersNotFound describes a response with status code 404, with default header values.

Resource was not found
*/
type PBXUsersNotFound struct {
	Payload *voip_models.Error
}

func (o *PBXUsersNotFound) Error() string {
	return fmt.Sprintf("[PUT /pbxusers][%d] pBXUsersNotFound  %+v", 404, o.Payload)
}
func (o *PBXUsersNotFound) GetPayload() *voip_models.Error {
	return o.Payload
}

func (o *PBXUsersNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(voip_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPBXUsersUnprocessableEntity creates a PBXUsersUnprocessableEntity with default headers values
func NewPBXUsersUnprocessableEntity() *PBXUsersUnprocessableEntity {
	return &PBXUsersUnprocessableEntity{}
}

/* PBXUsersUnprocessableEntity describes a response with status code 422, with default header values.

Unprocessable Entity, likely a bad parameter
*/
type PBXUsersUnprocessableEntity struct {
	Payload *voip_models.Error
}

func (o *PBXUsersUnprocessableEntity) Error() string {
	return fmt.Sprintf("[PUT /pbxusers][%d] pBXUsersUnprocessableEntity  %+v", 422, o.Payload)
}
func (o *PBXUsersUnprocessableEntity) GetPayload() *voip_models.Error {
	return o.Payload
}

func (o *PBXUsersUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(voip_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPBXUsersInternalServerError creates a PBXUsersInternalServerError with default headers values
func NewPBXUsersInternalServerError() *PBXUsersInternalServerError {
	return &PBXUsersInternalServerError{}
}

/* PBXUsersInternalServerError describes a response with status code 500, with default header values.

Server Internal Error
*/
type PBXUsersInternalServerError struct {
	Payload *voip_models.Error
}

func (o *PBXUsersInternalServerError) Error() string {
	return fmt.Sprintf("[PUT /pbxusers][%d] pBXUsersInternalServerError  %+v", 500, o.Payload)
}
func (o *PBXUsersInternalServerError) GetPayload() *voip_models.Error {
	return o.Payload
}

func (o *PBXUsersInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(voip_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
