// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Telnexus LLC
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package pbx_user

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/telnexus/lib/api/voip/voip_models"
)

// PostPBXUsersReader is a Reader for the PostPBXUsers structure.
type PostPBXUsersReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *PostPBXUsersReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewPostPBXUsersOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewPostPBXUsersUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewPostPBXUsersForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewPostPBXUsersNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewPostPBXUsersUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewPostPBXUsersInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		return nil, runtime.NewAPIError("response status code does not match any response statuses defined for this endpoint in the swagger spec", response, response.Code())
	}
}

// NewPostPBXUsersOK creates a PostPBXUsersOK with default headers values
func NewPostPBXUsersOK() *PostPBXUsersOK {
	return &PostPBXUsersOK{}
}

/* PostPBXUsersOK describes a response with status code 200, with default header values.

Telnexus Response with an array of PBX User objects
*/
type PostPBXUsersOK struct {
	Payload *voip_models.PbxUserResponse
}

func (o *PostPBXUsersOK) Error() string {
	return fmt.Sprintf("[POST /pbxusers][%d] postPBXUsersOK  %+v", 200, o.Payload)
}
func (o *PostPBXUsersOK) GetPayload() *voip_models.PbxUserResponse {
	return o.Payload
}

func (o *PostPBXUsersOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(voip_models.PbxUserResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostPBXUsersUnauthorized creates a PostPBXUsersUnauthorized with default headers values
func NewPostPBXUsersUnauthorized() *PostPBXUsersUnauthorized {
	return &PostPBXUsersUnauthorized{}
}

/* PostPBXUsersUnauthorized describes a response with status code 401, with default header values.

Access Unauthorized, invalid API-KEY was used
*/
type PostPBXUsersUnauthorized struct {
	Payload *voip_models.Error
}

func (o *PostPBXUsersUnauthorized) Error() string {
	return fmt.Sprintf("[POST /pbxusers][%d] postPBXUsersUnauthorized  %+v", 401, o.Payload)
}
func (o *PostPBXUsersUnauthorized) GetPayload() *voip_models.Error {
	return o.Payload
}

func (o *PostPBXUsersUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(voip_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostPBXUsersForbidden creates a PostPBXUsersForbidden with default headers values
func NewPostPBXUsersForbidden() *PostPBXUsersForbidden {
	return &PostPBXUsersForbidden{}
}

/* PostPBXUsersForbidden describes a response with status code 403, with default header values.

Access forbidden, account lacks access
*/
type PostPBXUsersForbidden struct {
	Payload *voip_models.Error
}

func (o *PostPBXUsersForbidden) Error() string {
	return fmt.Sprintf("[POST /pbxusers][%d] postPBXUsersForbidden  %+v", 403, o.Payload)
}
func (o *PostPBXUsersForbidden) GetPayload() *voip_models.Error {
	return o.Payload
}

func (o *PostPBXUsersForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(voip_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostPBXUsersNotFound creates a PostPBXUsersNotFound with default headers values
func NewPostPBXUsersNotFound() *PostPBXUsersNotFound {
	return &PostPBXUsersNotFound{}
}

/* PostPBXUsersNotFound describes a response with status code 404, with default header values.

Resource was not found
*/
type PostPBXUsersNotFound struct {
	Payload *voip_models.Error
}

func (o *PostPBXUsersNotFound) Error() string {
	return fmt.Sprintf("[POST /pbxusers][%d] postPBXUsersNotFound  %+v", 404, o.Payload)
}
func (o *PostPBXUsersNotFound) GetPayload() *voip_models.Error {
	return o.Payload
}

func (o *PostPBXUsersNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(voip_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostPBXUsersUnprocessableEntity creates a PostPBXUsersUnprocessableEntity with default headers values
func NewPostPBXUsersUnprocessableEntity() *PostPBXUsersUnprocessableEntity {
	return &PostPBXUsersUnprocessableEntity{}
}

/* PostPBXUsersUnprocessableEntity describes a response with status code 422, with default header values.

Unprocessable Entity, likely a bad parameter
*/
type PostPBXUsersUnprocessableEntity struct {
	Payload *voip_models.Error
}

func (o *PostPBXUsersUnprocessableEntity) Error() string {
	return fmt.Sprintf("[POST /pbxusers][%d] postPBXUsersUnprocessableEntity  %+v", 422, o.Payload)
}
func (o *PostPBXUsersUnprocessableEntity) GetPayload() *voip_models.Error {
	return o.Payload
}

func (o *PostPBXUsersUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(voip_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostPBXUsersInternalServerError creates a PostPBXUsersInternalServerError with default headers values
func NewPostPBXUsersInternalServerError() *PostPBXUsersInternalServerError {
	return &PostPBXUsersInternalServerError{}
}

/* PostPBXUsersInternalServerError describes a response with status code 500, with default header values.

Server Internal Error
*/
type PostPBXUsersInternalServerError struct {
	Payload *voip_models.Error
}

func (o *PostPBXUsersInternalServerError) Error() string {
	return fmt.Sprintf("[POST /pbxusers][%d] postPBXUsersInternalServerError  %+v", 500, o.Payload)
}
func (o *PostPBXUsersInternalServerError) GetPayload() *voip_models.Error {
	return o.Payload
}

func (o *PostPBXUsersInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(voip_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
