// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Telnexus LLC
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package phone_number

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewGetPhoneNumbersParams creates a new GetPhoneNumbersParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewGetPhoneNumbersParams() *GetPhoneNumbersParams {
	return &GetPhoneNumbersParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewGetPhoneNumbersParamsWithTimeout creates a new GetPhoneNumbersParams object
// with the ability to set a timeout on a request.
func NewGetPhoneNumbersParamsWithTimeout(timeout time.Duration) *GetPhoneNumbersParams {
	return &GetPhoneNumbersParams{
		timeout: timeout,
	}
}

// NewGetPhoneNumbersParamsWithContext creates a new GetPhoneNumbersParams object
// with the ability to set a context for a request.
func NewGetPhoneNumbersParamsWithContext(ctx context.Context) *GetPhoneNumbersParams {
	return &GetPhoneNumbersParams{
		Context: ctx,
	}
}

// NewGetPhoneNumbersParamsWithHTTPClient creates a new GetPhoneNumbersParams object
// with the ability to set a custom HTTPClient for a request.
func NewGetPhoneNumbersParamsWithHTTPClient(client *http.Client) *GetPhoneNumbersParams {
	return &GetPhoneNumbersParams{
		HTTPClient: client,
	}
}

/* GetPhoneNumbersParams contains all the parameters to send to the API endpoint
   for the get phone numbers operation.

   Typically these are written to a http.Request.
*/
type GetPhoneNumbersParams struct {

	/* Limit.

	   How many objects to return at one time (max 300, default 100)

	   Format: int64
	   Default: 100
	*/
	Limit *int64

	/* Offset.

	   How many objects to skip? (default 0)

	   Format: int64
	*/
	Offset *int64

	/* PhoneNumberID.

	   Telnexus Id of the Phone Number to be retrieved
	*/
	PhoneNumberID *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the get phone numbers params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetPhoneNumbersParams) WithDefaults() *GetPhoneNumbersParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the get phone numbers params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetPhoneNumbersParams) SetDefaults() {
	var (
		limitDefault = int64(100)

		offsetDefault = int64(0)
	)

	val := GetPhoneNumbersParams{
		Limit:  &limitDefault,
		Offset: &offsetDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the get phone numbers params
func (o *GetPhoneNumbersParams) WithTimeout(timeout time.Duration) *GetPhoneNumbersParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get phone numbers params
func (o *GetPhoneNumbersParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get phone numbers params
func (o *GetPhoneNumbersParams) WithContext(ctx context.Context) *GetPhoneNumbersParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get phone numbers params
func (o *GetPhoneNumbersParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the get phone numbers params
func (o *GetPhoneNumbersParams) WithHTTPClient(client *http.Client) *GetPhoneNumbersParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the get phone numbers params
func (o *GetPhoneNumbersParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithLimit adds the limit to the get phone numbers params
func (o *GetPhoneNumbersParams) WithLimit(limit *int64) *GetPhoneNumbersParams {
	o.SetLimit(limit)
	return o
}

// SetLimit adds the limit to the get phone numbers params
func (o *GetPhoneNumbersParams) SetLimit(limit *int64) {
	o.Limit = limit
}

// WithOffset adds the offset to the get phone numbers params
func (o *GetPhoneNumbersParams) WithOffset(offset *int64) *GetPhoneNumbersParams {
	o.SetOffset(offset)
	return o
}

// SetOffset adds the offset to the get phone numbers params
func (o *GetPhoneNumbersParams) SetOffset(offset *int64) {
	o.Offset = offset
}

// WithPhoneNumberID adds the phoneNumberID to the get phone numbers params
func (o *GetPhoneNumbersParams) WithPhoneNumberID(phoneNumberID *string) *GetPhoneNumbersParams {
	o.SetPhoneNumberID(phoneNumberID)
	return o
}

// SetPhoneNumberID adds the phoneNumberId to the get phone numbers params
func (o *GetPhoneNumbersParams) SetPhoneNumberID(phoneNumberID *string) {
	o.PhoneNumberID = phoneNumberID
}

// WriteToRequest writes these params to a swagger request
func (o *GetPhoneNumbersParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.Limit != nil {

		// query param limit
		var qrLimit int64

		if o.Limit != nil {
			qrLimit = *o.Limit
		}
		qLimit := swag.FormatInt64(qrLimit)
		if qLimit != "" {

			if err := r.SetQueryParam("limit", qLimit); err != nil {
				return err
			}
		}
	}

	if o.Offset != nil {

		// query param offset
		var qrOffset int64

		if o.Offset != nil {
			qrOffset = *o.Offset
		}
		qOffset := swag.FormatInt64(qrOffset)
		if qOffset != "" {

			if err := r.SetQueryParam("offset", qOffset); err != nil {
				return err
			}
		}
	}

	if o.PhoneNumberID != nil {

		// query param phoneNumberId
		var qrPhoneNumberID string

		if o.PhoneNumberID != nil {
			qrPhoneNumberID = *o.PhoneNumberID
		}
		qPhoneNumberID := qrPhoneNumberID
		if qPhoneNumberID != "" {

			if err := r.SetQueryParam("phoneNumberId", qPhoneNumberID); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
