// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Telnexus LLC
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package phone_number

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/telnexus/lib/api/voip/voip_models"
)

// NewPostPhoneNumbersParams creates a new PostPhoneNumbersParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewPostPhoneNumbersParams() *PostPhoneNumbersParams {
	return &PostPhoneNumbersParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewPostPhoneNumbersParamsWithTimeout creates a new PostPhoneNumbersParams object
// with the ability to set a timeout on a request.
func NewPostPhoneNumbersParamsWithTimeout(timeout time.Duration) *PostPhoneNumbersParams {
	return &PostPhoneNumbersParams{
		timeout: timeout,
	}
}

// NewPostPhoneNumbersParamsWithContext creates a new PostPhoneNumbersParams object
// with the ability to set a context for a request.
func NewPostPhoneNumbersParamsWithContext(ctx context.Context) *PostPhoneNumbersParams {
	return &PostPhoneNumbersParams{
		Context: ctx,
	}
}

// NewPostPhoneNumbersParamsWithHTTPClient creates a new PostPhoneNumbersParams object
// with the ability to set a custom HTTPClient for a request.
func NewPostPhoneNumbersParamsWithHTTPClient(client *http.Client) *PostPhoneNumbersParams {
	return &PostPhoneNumbersParams{
		HTTPClient: client,
	}
}

/* PostPhoneNumbersParams contains all the parameters to send to the API endpoint
   for the post phone numbers operation.

   Typically these are written to a http.Request.
*/
type PostPhoneNumbersParams struct {

	/* PhoneNumberRequest.

	   An array of new PBX records
	*/
	PhoneNumberRequest *voip_models.PhoneNumberRequest

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the post phone numbers params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PostPhoneNumbersParams) WithDefaults() *PostPhoneNumbersParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the post phone numbers params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PostPhoneNumbersParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the post phone numbers params
func (o *PostPhoneNumbersParams) WithTimeout(timeout time.Duration) *PostPhoneNumbersParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the post phone numbers params
func (o *PostPhoneNumbersParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the post phone numbers params
func (o *PostPhoneNumbersParams) WithContext(ctx context.Context) *PostPhoneNumbersParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the post phone numbers params
func (o *PostPhoneNumbersParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the post phone numbers params
func (o *PostPhoneNumbersParams) WithHTTPClient(client *http.Client) *PostPhoneNumbersParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the post phone numbers params
func (o *PostPhoneNumbersParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithPhoneNumberRequest adds the phoneNumberRequest to the post phone numbers params
func (o *PostPhoneNumbersParams) WithPhoneNumberRequest(phoneNumberRequest *voip_models.PhoneNumberRequest) *PostPhoneNumbersParams {
	o.SetPhoneNumberRequest(phoneNumberRequest)
	return o
}

// SetPhoneNumberRequest adds the phoneNumberRequest to the post phone numbers params
func (o *PostPhoneNumbersParams) SetPhoneNumberRequest(phoneNumberRequest *voip_models.PhoneNumberRequest) {
	o.PhoneNumberRequest = phoneNumberRequest
}

// WriteToRequest writes these params to a swagger request
func (o *PostPhoneNumbersParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.PhoneNumberRequest != nil {
		if err := r.SetBodyParam(o.PhoneNumberRequest); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
