// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Telnexus LLC
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package phone_number

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/telnexus/lib/api/voip/voip_models"
)

// PutPhoneNumbersReader is a Reader for the PutPhoneNumbers structure.
type PutPhoneNumbersReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *PutPhoneNumbersReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewPutPhoneNumbersOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewPutPhoneNumbersUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewPutPhoneNumbersForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewPutPhoneNumbersNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewPutPhoneNumbersUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewPutPhoneNumbersInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		return nil, runtime.NewAPIError("response status code does not match any response statuses defined for this endpoint in the swagger spec", response, response.Code())
	}
}

// NewPutPhoneNumbersOK creates a PutPhoneNumbersOK with default headers values
func NewPutPhoneNumbersOK() *PutPhoneNumbersOK {
	return &PutPhoneNumbersOK{}
}

/* PutPhoneNumbersOK describes a response with status code 200, with default header values.

Telnexus Response with an array of PBX objects
*/
type PutPhoneNumbersOK struct {
	Payload *voip_models.PhoneNumberResponse
}

func (o *PutPhoneNumbersOK) Error() string {
	return fmt.Sprintf("[PUT /phonenumbers][%d] putPhoneNumbersOK  %+v", 200, o.Payload)
}
func (o *PutPhoneNumbersOK) GetPayload() *voip_models.PhoneNumberResponse {
	return o.Payload
}

func (o *PutPhoneNumbersOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(voip_models.PhoneNumberResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutPhoneNumbersUnauthorized creates a PutPhoneNumbersUnauthorized with default headers values
func NewPutPhoneNumbersUnauthorized() *PutPhoneNumbersUnauthorized {
	return &PutPhoneNumbersUnauthorized{}
}

/* PutPhoneNumbersUnauthorized describes a response with status code 401, with default header values.

Access Unauthorized, invalid API-KEY was used
*/
type PutPhoneNumbersUnauthorized struct {
	Payload *voip_models.Error
}

func (o *PutPhoneNumbersUnauthorized) Error() string {
	return fmt.Sprintf("[PUT /phonenumbers][%d] putPhoneNumbersUnauthorized  %+v", 401, o.Payload)
}
func (o *PutPhoneNumbersUnauthorized) GetPayload() *voip_models.Error {
	return o.Payload
}

func (o *PutPhoneNumbersUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(voip_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutPhoneNumbersForbidden creates a PutPhoneNumbersForbidden with default headers values
func NewPutPhoneNumbersForbidden() *PutPhoneNumbersForbidden {
	return &PutPhoneNumbersForbidden{}
}

/* PutPhoneNumbersForbidden describes a response with status code 403, with default header values.

Access forbidden, account lacks access
*/
type PutPhoneNumbersForbidden struct {
	Payload *voip_models.Error
}

func (o *PutPhoneNumbersForbidden) Error() string {
	return fmt.Sprintf("[PUT /phonenumbers][%d] putPhoneNumbersForbidden  %+v", 403, o.Payload)
}
func (o *PutPhoneNumbersForbidden) GetPayload() *voip_models.Error {
	return o.Payload
}

func (o *PutPhoneNumbersForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(voip_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutPhoneNumbersNotFound creates a PutPhoneNumbersNotFound with default headers values
func NewPutPhoneNumbersNotFound() *PutPhoneNumbersNotFound {
	return &PutPhoneNumbersNotFound{}
}

/* PutPhoneNumbersNotFound describes a response with status code 404, with default header values.

Resource was not found
*/
type PutPhoneNumbersNotFound struct {
	Payload *voip_models.Error
}

func (o *PutPhoneNumbersNotFound) Error() string {
	return fmt.Sprintf("[PUT /phonenumbers][%d] putPhoneNumbersNotFound  %+v", 404, o.Payload)
}
func (o *PutPhoneNumbersNotFound) GetPayload() *voip_models.Error {
	return o.Payload
}

func (o *PutPhoneNumbersNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(voip_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutPhoneNumbersUnprocessableEntity creates a PutPhoneNumbersUnprocessableEntity with default headers values
func NewPutPhoneNumbersUnprocessableEntity() *PutPhoneNumbersUnprocessableEntity {
	return &PutPhoneNumbersUnprocessableEntity{}
}

/* PutPhoneNumbersUnprocessableEntity describes a response with status code 422, with default header values.

Unprocessable Entity, likely a bad parameter
*/
type PutPhoneNumbersUnprocessableEntity struct {
	Payload *voip_models.Error
}

func (o *PutPhoneNumbersUnprocessableEntity) Error() string {
	return fmt.Sprintf("[PUT /phonenumbers][%d] putPhoneNumbersUnprocessableEntity  %+v", 422, o.Payload)
}
func (o *PutPhoneNumbersUnprocessableEntity) GetPayload() *voip_models.Error {
	return o.Payload
}

func (o *PutPhoneNumbersUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(voip_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutPhoneNumbersInternalServerError creates a PutPhoneNumbersInternalServerError with default headers values
func NewPutPhoneNumbersInternalServerError() *PutPhoneNumbersInternalServerError {
	return &PutPhoneNumbersInternalServerError{}
}

/* PutPhoneNumbersInternalServerError describes a response with status code 500, with default header values.

Server Internal Error
*/
type PutPhoneNumbersInternalServerError struct {
	Payload *voip_models.Error
}

func (o *PutPhoneNumbersInternalServerError) Error() string {
	return fmt.Sprintf("[PUT /phonenumbers][%d] putPhoneNumbersInternalServerError  %+v", 500, o.Payload)
}
func (o *PutPhoneNumbersInternalServerError) GetPayload() *voip_models.Error {
	return o.Payload
}

func (o *PutPhoneNumbersInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(voip_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
