// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Telnexus LLC
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package queue

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/telnexus/lib/api/voip/voip_models"
)

// NewPutQueuesParams creates a new PutQueuesParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewPutQueuesParams() *PutQueuesParams {
	return &PutQueuesParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewPutQueuesParamsWithTimeout creates a new PutQueuesParams object
// with the ability to set a timeout on a request.
func NewPutQueuesParamsWithTimeout(timeout time.Duration) *PutQueuesParams {
	return &PutQueuesParams{
		timeout: timeout,
	}
}

// NewPutQueuesParamsWithContext creates a new PutQueuesParams object
// with the ability to set a context for a request.
func NewPutQueuesParamsWithContext(ctx context.Context) *PutQueuesParams {
	return &PutQueuesParams{
		Context: ctx,
	}
}

// NewPutQueuesParamsWithHTTPClient creates a new PutQueuesParams object
// with the ability to set a custom HTTPClient for a request.
func NewPutQueuesParamsWithHTTPClient(client *http.Client) *PutQueuesParams {
	return &PutQueuesParams{
		HTTPClient: client,
	}
}

/* PutQueuesParams contains all the parameters to send to the API endpoint
   for the put queues operation.

   Typically these are written to a http.Request.
*/
type PutQueuesParams struct {

	/* QueueRequest.

	   An array of new Queues
	*/
	QueueRequest *voip_models.QueueRequest

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the put queues params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PutQueuesParams) WithDefaults() *PutQueuesParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the put queues params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PutQueuesParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the put queues params
func (o *PutQueuesParams) WithTimeout(timeout time.Duration) *PutQueuesParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the put queues params
func (o *PutQueuesParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the put queues params
func (o *PutQueuesParams) WithContext(ctx context.Context) *PutQueuesParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the put queues params
func (o *PutQueuesParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the put queues params
func (o *PutQueuesParams) WithHTTPClient(client *http.Client) *PutQueuesParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the put queues params
func (o *PutQueuesParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithQueueRequest adds the queueRequest to the put queues params
func (o *PutQueuesParams) WithQueueRequest(queueRequest *voip_models.QueueRequest) *PutQueuesParams {
	o.SetQueueRequest(queueRequest)
	return o
}

// SetQueueRequest adds the queueRequest to the put queues params
func (o *PutQueuesParams) SetQueueRequest(queueRequest *voip_models.QueueRequest) {
	o.QueueRequest = queueRequest
}

// WriteToRequest writes these params to a swagger request
func (o *PutQueuesParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.QueueRequest != nil {
		if err := r.SetBodyParam(o.QueueRequest); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
