// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Telnexus LLC
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package queue

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
)

// New creates a new queue API client.
func New(transport runtime.ClientTransport, formats strfmt.Registry) ClientService {
	return &Client{transport: transport, formats: formats}
}

/*
Client for queue API
*/
type Client struct {
	transport runtime.ClientTransport
	formats   strfmt.Registry
}

// ClientOption is the option for Client methods
type ClientOption func(*runtime.ClientOperation)

// ClientService is the interface for Client methods
type ClientService interface {
	GetQueues(params *GetQueuesParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*GetQueuesOK, error)

	PostQueues(params *PostQueuesParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*PostQueuesOK, error)

	PutQueues(params *PutQueuesParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*PutQueuesOK, error)

	SetTransport(transport runtime.ClientTransport)
}

/*
  GetQueues gets a list of queues

  Return a list of available Queues
*/
func (a *Client) GetQueues(params *GetQueuesParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*GetQueuesOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewGetQueuesParams()
	}
	op := &runtime.ClientOperation{
		ID:                 "getQueues",
		Method:             "GET",
		PathPattern:        "/queues",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &GetQueuesReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	}
	for _, opt := range opts {
		opt(op)
	}

	result, err := a.transport.Submit(op)
	if err != nil {
		return nil, err
	}
	success, ok := result.(*GetQueuesOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for getQueues: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

/*
  PostQueues adds new queues

  Create new Queues
*/
func (a *Client) PostQueues(params *PostQueuesParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*PostQueuesOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewPostQueuesParams()
	}
	op := &runtime.ClientOperation{
		ID:                 "postQueues",
		Method:             "POST",
		PathPattern:        "/queues",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &PostQueuesReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	}
	for _, opt := range opts {
		opt(op)
	}

	result, err := a.transport.Submit(op)
	if err != nil {
		return nil, err
	}
	success, ok := result.(*PostQueuesOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for postQueues: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

/*
  PutQueues updates queues

  Update fields in Queue records identified by Telnexus Id
*/
func (a *Client) PutQueues(params *PutQueuesParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*PutQueuesOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewPutQueuesParams()
	}
	op := &runtime.ClientOperation{
		ID:                 "putQueues",
		Method:             "PUT",
		PathPattern:        "/queues",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &PutQueuesReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	}
	for _, opt := range opts {
		opt(op)
	}

	result, err := a.transport.Submit(op)
	if err != nil {
		return nil, err
	}
	success, ok := result.(*PutQueuesOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for putQueues: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

// SetTransport changes the transport on the client
func (a *Client) SetTransport(transport runtime.ClientTransport) {
	a.transport = transport
}
