// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Telnexus LLC
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package vm_box

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/telnexus/lib/api/voip/voip_models"
)

// GetVMBoxesReader is a Reader for the GetVMBoxes structure.
type GetVMBoxesReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetVMBoxesReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetVMBoxesOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewGetVMBoxesUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewGetVMBoxesForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewGetVMBoxesNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewGetVMBoxesUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewGetVMBoxesInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		return nil, runtime.NewAPIError("response status code does not match any response statuses defined for this endpoint in the swagger spec", response, response.Code())
	}
}

// NewGetVMBoxesOK creates a GetVMBoxesOK with default headers values
func NewGetVMBoxesOK() *GetVMBoxesOK {
	return &GetVMBoxesOK{}
}

/* GetVMBoxesOK describes a response with status code 200, with default header values.

Telnexus Response with an array of PBX objects
*/
type GetVMBoxesOK struct {
	Payload *voip_models.VMBoxResponse
}

func (o *GetVMBoxesOK) Error() string {
	return fmt.Sprintf("[GET /vmboxes][%d] getVmBoxesOK  %+v", 200, o.Payload)
}
func (o *GetVMBoxesOK) GetPayload() *voip_models.VMBoxResponse {
	return o.Payload
}

func (o *GetVMBoxesOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(voip_models.VMBoxResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetVMBoxesUnauthorized creates a GetVMBoxesUnauthorized with default headers values
func NewGetVMBoxesUnauthorized() *GetVMBoxesUnauthorized {
	return &GetVMBoxesUnauthorized{}
}

/* GetVMBoxesUnauthorized describes a response with status code 401, with default header values.

Access Unauthorized, invalid API-KEY was used
*/
type GetVMBoxesUnauthorized struct {
	Payload *voip_models.Error
}

func (o *GetVMBoxesUnauthorized) Error() string {
	return fmt.Sprintf("[GET /vmboxes][%d] getVmBoxesUnauthorized  %+v", 401, o.Payload)
}
func (o *GetVMBoxesUnauthorized) GetPayload() *voip_models.Error {
	return o.Payload
}

func (o *GetVMBoxesUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(voip_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetVMBoxesForbidden creates a GetVMBoxesForbidden with default headers values
func NewGetVMBoxesForbidden() *GetVMBoxesForbidden {
	return &GetVMBoxesForbidden{}
}

/* GetVMBoxesForbidden describes a response with status code 403, with default header values.

Access forbidden, account lacks access
*/
type GetVMBoxesForbidden struct {
	Payload *voip_models.Error
}

func (o *GetVMBoxesForbidden) Error() string {
	return fmt.Sprintf("[GET /vmboxes][%d] getVmBoxesForbidden  %+v", 403, o.Payload)
}
func (o *GetVMBoxesForbidden) GetPayload() *voip_models.Error {
	return o.Payload
}

func (o *GetVMBoxesForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(voip_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetVMBoxesNotFound creates a GetVMBoxesNotFound with default headers values
func NewGetVMBoxesNotFound() *GetVMBoxesNotFound {
	return &GetVMBoxesNotFound{}
}

/* GetVMBoxesNotFound describes a response with status code 404, with default header values.

Resource was not found
*/
type GetVMBoxesNotFound struct {
	Payload *voip_models.Error
}

func (o *GetVMBoxesNotFound) Error() string {
	return fmt.Sprintf("[GET /vmboxes][%d] getVmBoxesNotFound  %+v", 404, o.Payload)
}
func (o *GetVMBoxesNotFound) GetPayload() *voip_models.Error {
	return o.Payload
}

func (o *GetVMBoxesNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(voip_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetVMBoxesUnprocessableEntity creates a GetVMBoxesUnprocessableEntity with default headers values
func NewGetVMBoxesUnprocessableEntity() *GetVMBoxesUnprocessableEntity {
	return &GetVMBoxesUnprocessableEntity{}
}

/* GetVMBoxesUnprocessableEntity describes a response with status code 422, with default header values.

Unprocessable Entity, likely a bad parameter
*/
type GetVMBoxesUnprocessableEntity struct {
	Payload *voip_models.Error
}

func (o *GetVMBoxesUnprocessableEntity) Error() string {
	return fmt.Sprintf("[GET /vmboxes][%d] getVmBoxesUnprocessableEntity  %+v", 422, o.Payload)
}
func (o *GetVMBoxesUnprocessableEntity) GetPayload() *voip_models.Error {
	return o.Payload
}

func (o *GetVMBoxesUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(voip_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetVMBoxesInternalServerError creates a GetVMBoxesInternalServerError with default headers values
func NewGetVMBoxesInternalServerError() *GetVMBoxesInternalServerError {
	return &GetVMBoxesInternalServerError{}
}

/* GetVMBoxesInternalServerError describes a response with status code 500, with default header values.

Server Internal Error
*/
type GetVMBoxesInternalServerError struct {
	Payload *voip_models.Error
}

func (o *GetVMBoxesInternalServerError) Error() string {
	return fmt.Sprintf("[GET /vmboxes][%d] getVmBoxesInternalServerError  %+v", 500, o.Payload)
}
func (o *GetVMBoxesInternalServerError) GetPayload() *voip_models.Error {
	return o.Payload
}

func (o *GetVMBoxesInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(voip_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
