// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Telnexus LLC
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package voip_models

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"

	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// Queue queue
//
// swagger:model Queue
type Queue struct {

	// Pre-defined wait period applied after an agent handles a customer call (in seconds)
	AgentWrapupTime int64 `json:"AgentWrapupTime,omitempty"`

	// If set to true and a recipient rejects a call, they will be forced to away state
	ForceAwayOnReject bool `json:"ForceAwayOnReject,omitempty"`

	// Media ID (or appropriate media URI) of media to play while caller is on hold.
	HoldTreatment string `json:"HoldTreatment,omitempty"`

	// Telnexus Record Identifier
	ID string `json:"ID,omitempty"`

	// A friendly name for the queue
	Name string `json:"Name,omitempty"`

	// The queue router used for routing and delivering calls to recipients
	QueueRouter *string `json:"QueueRouter,omitempty"`

	// The type of queue
	QueueType string `json:"QueueType,omitempty"`

	// Amount of time in seconds that qubicle will wait while ringing for the agent to successfully answer a call.
	RingTimeout int64 `json:"RingTimeout,omitempty"`

	// The time between delivery ticks in milliseconds
	TickTime int64 `json:"TickTime,omitempty"`

	// The maximum amount of time in seconds that a call will wait in queue.
	Timeout int64 `json:"Timeout,omitempty"`

	// If set to a non-zero value the queue will immediately time out any call entering the queue over the size
	TimeoutIfSizeExceeds int64 `json:"TimeoutIfSizeExceeds,omitempty"`

	// If set to true and a call enters the queue while it has no logged in agents, the call will time out
	TimeoutImmediatelyIfEmpty bool `json:"TimeoutImmediatelyIfEmpty,omitempty"`

	// The ID of a queue that the call will be sent to in the event of a timeout
	TimoutRedirect string `json:"TimoutRedirect,omitempty"`
}

// Validate validates this queue
func (m *Queue) Validate(formats strfmt.Registry) error {
	return nil
}

// ContextValidate validates this queue based on context it is used
func (m *Queue) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	return nil
}

// MarshalBinary interface implementation
func (m *Queue) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *Queue) UnmarshalBinary(b []byte) error {
	var res Queue
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}
